(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)







BeginPackage["MathCodeConv`",{"SafeMathProg`"}];




(* Internal Needs *)
(* Needs["MathCodeCommands`"];*)
Needs["MathCodeLanguage`"];
Needs["MCUtilities`"];
Needs["MathCodeConvSymb`"];


Off[General::"spell"];
Off[General::"spell1"];



(Begin["MathCodeConv`"];)

(* The main function is convPackage which converts and prints
  a whole package to ObjectMath 4.0 form. Other relevant top level functions
  are defConv for converting any kind of (typed) definition.
  *)

(* Data structures *)

mc$$MacroRules;		(* Stores the macro rules assigned by the MacroRules option *)
mc$$InterpMacroRules; (* Stores the macro rules assigned by declInterp*) (* Added by AK *)

(* Functions *)
funcSymbolicExpand;           (* Compiler! Symbolic evaluation/expansion
								of func body *)
initializeSymbolic;           (* Compiler! Temporary symbolic initialization
								 of array vars *)
mkInitPackageFunc;            (* Define var. initialization function for package *)
convPackage;                  (* Top level function to convert a package *)
typeOnly;					(* Option to convPackage *)
templateGen;				(* Option to convPackage *)
mathHeader;					(* Option to convPackage *)	
defConv;                      (* Top level func to convert any definition *)
declInterp;						(* Added by AK *)
computeGrid;                    (* Added by AK *)
computeCoeff;                    (* Added by AK *)
computeInterpMacros;             (* Added by AK *)

(** Future Private Functions **)
defConv2;                     (* Help function to defConv *)
conditionsConv;               (* Make If-stmt of rule conditions. Incomplete *)
bodyC2;                       (* Help function to conditionsConv *)
bodyC3;                       (* Help function to conditionsConv *)

funcConv;                     (* Conversion of function (variable) defs *)

replaceFuncTypes;             (* Real=>real,Integer=>int, etc... *)
replaceDeclTypes;             (* Real x_ =>real x, Integer y_=>int y,... *)
mkMCIBody;                 (* Convert function body to Omath4 AST form *)
mkMCIBlock;                (* Convert block inside body to Omath4 form *)
flattenBlock;				(* Remove nested blocks *)
findMissplaceCompundExpr;	(* Finds nested CompoundExpressions *)
moveCompoundExpr;			(* Moves nested CompoundExpressions outwards *)
statementpattern;			(* Pattern for statement heads *)
bodyPass1;					(* Includes several transformation from above *)
localInitConv;				(* Moves non simple initializers of local variables *)
tensorType;					(* Computes type of list constructors *)
tensorType2;				(* Help function to tensorType *)
listConstructor;			(* Replace list contructors with temporal variable *)
listConstructor2;			(* Help function to listConstructor *)

bodyConv;                     (* Convert function body *)
body2Part;                    (* Help function to bodyConv *)
bodyConv2;                    (* Help function to bodyConv *)
bodyFinalTrans;               (* Help fn to bodyConv. Apply bodyFinalTransRules *)
bodyFinalTransRules;          (* rules applied before final Omath4 bodycode gen *)

headConv;                     (* Convert function head *)
headConv2;                    (* Help function to headConv *)
mktypedarg;                   (* Attach type to function argument *)

bodyConvExternal;			  (* Converts external body to omath4 *)

ConvMap;					(* Converts Map *)
ConvApply;					(* Convert Apply *)					

replaceIterators;			(* Converts Do, Array, and Table to For loops *)
uniqueIteratorRule;			(* Help function to replaceIterators *)
templateDo;					(* Help function to replaceIterators *)
IterTrans;					(* Help function to replaceIterators *)
iteratorHeads;				(* Help function to replaceIterators *)
iterSymbols;				(* Help function to replaceIterators *)

makeForeignDefinition;		(* Sets the rhs of a foreign symbol to
							ExternalFunction *)
writeCallBacksMCI;			(* Creates call back entries in om4 file *)


(* These functions are obsolete for the moment *)
 outFuncMathLinkTempl;         (* Output Mathlink function template on file *)
  mkFuncPattern2;               (* Help func. Make function head+param patters *)
  mkArgNames2;                  (* Help func. Extract list of arg names *)
  mkArgPattern2;                (* Help func. Make an argument type pattern *)
  mkOutType2;                   (* Help func. Make an argument type *)
  mkOutTypes2;                  (* Help func. Make the list of argument types *)
  
(** Private made public due to SafeMath **)
translationErrorFlg;  (* Set to True if error during translation e.g. by 
                       * convPackage. *)
mkArgSubstList; mkArgSubst; 	(* creates a substitution list to P$ context prefix
							   for parameter names from Mathematica function
							   parameter list *)

(* Markers for listConstructor *)
LIST;
SEARCH;

mc$StandardRules;			(* Standard rules applied after macro rules *)


End[];



(Begin["MathCodeConv`Private`"];)



End[];







BeginFunction[computeInterpMacros];(*Added by AK*)

computeInterpMacros[interpNames_, context_]:=
    Module[{sWeights,sGrids,intptmp,gRules,sinterpNames},
      (* Adds a string specifying the contexts to the symbols.
            Any other context specification will be plattened out since
          all these variables must be created in the current package,
         -JG *)
      
      sinterpNames=
        (StringJoin[context,StringReplace[# , "`"\[Rule]"$T"]])&/@ 
          interpNames;
      sWeights=
        (StringJoin[context,StringReplace[# , "`"\[Rule]"$T"],"Weights"])&/@ 
          interpNames;
      sGrids=
        (StringJoin[context,StringReplace[# , "`"\[Rule]"$T"],"Grids"])&/@ 
          interpNames;
      
      (Clear[#])&/@ sWeights;
      (Clear[#])&/@ sGrids;
      
      intptmp=ToExpression[sinterpNames];
      (Clear[#])&/@sinterpNames;
      
      gRules=
        MapThread[
          (Hold[
                HoldPattern[#1[args__]]\[RuleDelayed]
                  InterpolationTools`RBInterp[#2,#3,{args}]])&,
          {ToExpression[sinterpNames],ToExpression[sWeights],
            ToExpression[sGrids]}];
      Evaluate[ToExpression[sinterpNames]]=intptmp;
      ReleaseHold[gRules]
      ];

EndFunction[];





BeginFunction[ComputeGrid];(*Added by AK*)

ComputeGrid[intpfcn_]:=Module[{xdata,ydata,nFlatten,gridPt},
      
      (*xdata=N[intpfcn][[1,3]];  
         ydata=N[intpfcn][[1,4,2]];*)
      xdata=InputForm[N[intpfcn]][[1,3]];
      	
      If[$VersionNumber\[Equal]4, 
        ydata=InputForm[N[intpfcn]][[1,4,2]];,
        ydata=InputForm[N[intpfcn]][[1,4]];
        ];
      
       nFlatten=First[Dimensions[xdata]];
      gridPt=Flatten[Apply[Outer[List,##]&,xdata],nFlatten-1]
      (*Compute the grid points*)
      
      ];

EndFunction[];





BeginFunction[ComputeCoeff];(*Added by AK*)

ComputeCoeff[intpfcn_]:=Module[{xdata,ydata,nFlatten,phiM,gridPt,weights},
      	xdata=InputForm[N[intpfcn]][[1,3]];
      	If[$VersionNumber\[Equal]4,
        ydata=InputForm[N[intpfcn]][[1,4,2]];,
        ydata=InputForm[N[intpfcn]][[1,4]];
        ];	
             
      (*xdata=N[intpfcn][[1,3]];  
          ydata=N[intpfcn][[1,4,2]];*)
       nFlatten=First[Dimensions[xdata]];
      	
      	gridPt=
        Flatten[Apply[Outer[List,##]&,xdata],
          nFlatten-1];(*Compute the grid points*)
      				    
      phiM=Map[(Sqrt[#.#+0.01])&,
          Outer[(#1-#2)&,gridPt,gridPt,
            1],{2}];(*Compute the distance matrix*)
      		(*Compute w_i*)
      	weights=LinearSolve[phiM, Flatten[ydata,2]]//Chop;
        
      	weights
      	];
EndFunction[];





BeginFunction[declInterp](*Added by AK*)

declInterp[interpNames_, context_]:=
    Module[{sWeights,sGrids,weights,grids,gWeights,gGrid,sinterpNames},
      (* Adds a string specifying the contexts to the symbols.
            Any other context specification will be plattened out since
           
          all these variables must be created in the current package, -JG *)
      
      sinterpNames=(StringJoin[context,StringReplace[# , "`"\[Rule]"$T"]])&/@ 
          interpNames;
      sWeights=(StringJoin[context,StringReplace[# , "`"\[Rule]"$T"],
                "Weights"])&/@ interpNames;
      sGrids=(StringJoin[context,StringReplace[# , "`"\[Rule]"$T"],"Grids"])&/@ 
          interpNames;
      
      (Clear[#])&/@ sWeights;
      (Clear[#])&/@ sGrids;
      
      weights=ComputeCoeff[#]&/@ ToExpression[sinterpNames];
      grids=ComputeGrid[#]&/@ToExpression[sinterpNames];
      
      gWeights=
        MapThread[(Hold[Declare[Real[_] #1=#2]])&, {ToExpression[sWeights],
            weights}];
      gGrid=
        MapThread[(Hold[Declare[Real[_,_] #1=#2]])&, {ToExpression[sGrids],
            grids}];
      
      ReleaseHold[gWeights];
             ReleaseHold[gGrid];
       
      ];

EndFunction[];







(* funcSymbolicExpand;  Symbolic evaluation/expansion of func body *)

BeginFunction[funcSymbolicExpand]

SetAttributes[funcSymbolicExpand, {HoldAll,Listable}];

funcSymbolicExpand::notallowed="For,Do,While or non-value-returning If[] are not allowed in the body of function `1` when it is symbolically evaluated for code generation, due to the following code:\n`2`";

funcSymbolicExpand[Hold[fname_] | fname_, pretty:(True|False):False] :=
Module[{
  anames =getAllVariableNames[],
  expr2,
  names2,
  funcrule = DownValues[fname][[1]],
  paramnames = Replace[standardizeTypes[getDefinition[fname]],
	    		Hold[$$Decl[{}, t_List -> _, _[par___]] := _] :> Hold[par]
	    	] /. Verbatim[Pattern][x_,_] :> x,
  paramtypes,
  replacerules,
  body,
  MARKER,
  tmp
 },
  Replace[Join[anames,paramnames],
	Hold[vars___] :> 
	  Block[{vars},  (* A Block to prevent expanding variables *)
	    (* Extract function parameter names and types *)
	    (* paramnames = extractLocalAndParamNames[funcrule[[1]]]; *)
	    
	    paramtypes = Cases[standardizeTypes[getDefinition[fname]],
          HoldPattern[$$Decl[{}, t_List -> _, _]] :> t,Infinity];
          
        (* Create rules for expanding parameters of matrix types *)  
        replacerules = 
        	Join[
        	Cases[Thread[{paramnames, Hold@@paramtypes[[1]]},Hold],
           HoldPattern[{symb_Symbol, ArrayOf[_, {dim__Integer}]}] :> 
            (symb -> Array[MARKER[Part][symb, ##1] & , {dim}])],
            
            (* Create rules preventing local variables, representing
               parameter dimensions, from being evaluated *) 
            Cases[Thread[{paramnames, Hold@@paramtypes[[1]]},Hold],
           HoldPattern[{symb_Symbol, ArrayOf[_, {___}]}] :> 
            (HoldPattern[Dimensions[symb][[i__]]] :>
            	MARKER[Part][MARKER[Dimensions][symb],i])]
            ];
           
        (*
        Print["paramnames: ",paramnames];
        Print["paramtypes: ",paramtypes];
        Print["replacerules: ",replacerules];
        *)       
            
       (* Apply the rules on the body part*)
        body = Extract[funcrule,2,Hold] /. replacerules;
       	   
        If[!pretty,
         	(* Construct replace rules to P$ context for param names *)
        	replacerules = Apply[List,
                     Map[mkContextNameReplaceRule[##,"P$`"]&, paramnames ]];
        	(* perform the replacement *)
	    	body = body /. replacerules;
	    ];
	    
	    (* Detect For,Do,If,While not supported by symbolic expand *)
	    (* ?? Another option, avoid expanding those parts. ??Omath4 *)
        If[(tmp=Cases[body, 
	             HoldPattern[
	                  errcode:((For|Do|While)[__] | 
	                  CompoundExpression[___, If[___],__])] :> HoldForm[errcode],
	             Infinity
	            ]) =!= {},
          Throw[
          	Message[funcSymbolicExpand::notallowed,HoldForm[fname],
          		 SequenceForm@@tmp ];
            $Failed
           ]
       	];
       	(* Initialize the global variables *)
       	
   	    (* If pretty is True we want a normal expasion of the globals
   	    	using Part *)
   	    If[pretty,
   	    	initializeSymbolic[List @@ Hold /@ Hold[vars],MARKER]
   	    ,
   	    	initializeSymbolic[List @@ Hold /@ Hold[vars]]
   	    ]; 
	    
	    (* The following code is the old version using two expansion
	       phases *)
	    (* This does 1:st symbolic expansion *)
  	    (* expr2 = funcrule[[2]]; 
	     * names2 = Cases[expr2 , name_Symbol :> Hold[name],Infinity]; *)
	    (* expand non-constant array vars into symbolic components *)
	    (* initializeSymbolic[names2];*)
	    
        (* 2:nd expansion, i.e. array vars, & Convert into string. *)
	    (* contextToString[FullForm[expr2,NumberMarks->False]] *)
	    
	    
	    (* Print["body: ",body];*)
	    
	     
	    (* Expand, Hold and then remove the MARKERs *)
	    
	    (* Turn off the warnings of Part used on symbols *)
	    Off[Part::pspec];
	    Off[Part::partw];
	    
	    (* Rebind If to let all control branches be evaluated symbolically *)
	    expr2 = 
	    	Block[{evaluatedIf},
	    		Block[{If},
	    			(* If True or False is found in the If statements the correp.
	    	 		  branch should be returned, before the false branch is
	    	 		  evaluated. *)
	    	 		SetAttributes[If,HoldRest];
	    	 		If[True, then_, ___] := then;
	    	 		If[False, _, else_] := else;
	    	 		If[cond_,then_,else_] := evaluatedIf[cond,then,else];
	    	 
	    	 		(* Expand, Hold and then remove the MARKERs *) 
	    			(Hold@@(
	    		 		(List@@ body)
	    		 		(* To improve the symbolic expansion replace
	    		 	   		the reals 0. and 1. with integers 0 and 1 *)
	    		 	 	(* This can cause problems. Remove for now
	    		 	  	 /. {1.->1, 0.->0} *)
	    		 ))
	    		] /. evaluatedIf -> If
	    	] /. (MARKER[Hold[x_] | x_]):>x;
	    (* Turn this warning message back on *)
	    On[Part::pspec];
	    On[Part::partw];
	    
	   (*   Print["expr2: ",expr2];    *)
	    
	    (* Only 2 arguments in Part is allowed *)
	    expr2 = body2Part[expr2];
	    
	    (* More transformations from normal convertion might be
	    	needed in future *)	
	    If[!ValueQ[mc$$MacroRules], mc$$MacroRules={}];
		expr2 = expr2 //.  mc$$MacroRules;
	
	    	
	    (* Produce the output *)
	    If[pretty,
	    	(* Return the normal expression *)
	    	expr2
	    ,
	    	(* Return string formatted for GenerateEvaluateFunctionInternal *)
	    	contextToString[Replace[
	    		bodyFinalTrans[expr2],
	    		Hold[x___]:>HoldForm[FullForm[x,NumberMarks->False]]]]
	    ]
	  ]
  ]
];

EndFunction[];

(* initializeSymbolic Temporary symbolic initialization of array vars *)

BeginFunction[initializeSymbolic]

SetAttributes[initializeSymbolic, Listable];

(* Initialize arrays to symbolic elements, e.g. a vector a of 3 elements
 * can become {a$C[1],a$C[2],a$C[3]}
 *)

initializeSymbolic[Hold[varname_], mark_Symbol:Null] := Module[{
  v2
},
  Replace[getTypeInfo[varname],
    $$Decl[_,ArrayOf[type1_,dims_List]] :> (
      (* Only initialize if an array, and dimensions are integers *)
      If[MatchQ[dims,{__Integer}],
      	varname = 
      		If[mark===Null,
      			(* Do the Peter variant *)
      			Array[
          			Symbol["om$"<>Context[varname]<>
          			SymbolName[Unevaluated[varname]]<>"$C"],
          			dims
        		]
        	,
        		(* Do the Johan variant. Both mark and Hold the Part *)
        		Array[mark[Hold[Part[varname, ##]]] & , dims]
        	]
      ]
    )
  ];
]

EndFunction[];





















(* mkInitPackageFunc;             Define var. initialization function for package *)

BeginFunction[mkInitPackageFunc]



mkInitPackageFunc[packname_String] := Module[{
  varnames = getPackageVariables[packname],
  vardefs,
  varinits
},

  vardefs = Apply[List,Map[getDefinition, varnames]];
  varinits = Cases[vardefs, 
                   Hold[hd_ = init_] /; (FreeQ[Hold[hd],Constant] &&
                   FreeQ[Hold[init],ExternalVariable]) :> Hold[hd=init]];
  varinits = Apply[Hold,varinits];
  If[varinits=!=Hold[], varinits=Flatten[varinits]];
  (* Elaborate and promotion of right hand side to arrays only for scalars *)
  varinits = mkElaboratedVars[varinits,
    staticDecl->False,keepTypes->False,constDecl->False,arrayAllocInit->True];
  (* In certain cases convert to shorter forms like  vec1[_]=3. *) 
  varinits = varinits /. {
    HoldPattern[var2_Symbol = Table[const2:(_Real|_Integer|_Complex|_String),{dim1_}]] :>
      (var2[[_]] = const2),
    HoldPattern[var2_Symbol = Table[const2:(_Real|_Integer|_Complex|_String),{dim1_,dim2_}]] :>
      (var2[[_,_]] = const2)
  };
  (* Define the initialization function *)
  Replace[{Symbol[packname<>"`"<>packname<>"Init"],varinits},
    HoldPattern[{initfuncname_,Hold[inits___]}] :> (
      If[varinits===Hold[],
        TypedSetDelayed[({}->Null) initfuncname[], 
               VoidFunc[]],
        TypedSetDelayed[({}->Null) initfuncname[], 
               Module[{},CompoundExpression[inits,Null]]]
      ]
    )
  ]
]

EndFunction[];












(*  convPackage
                  - convert all typed definitions in a package 
                    for the purpose of later code generation *) 
                      
BeginFunction[convPackage]; 
 
convPackage::usage =  
"convPackage[filename, \"packagename\", Hold[names...]] converts and outputs the typed global variables and function definitions in Hold[names...] into MathCode internal form for the purpose of later code generation into e.g. C++ or Fortran90. \n 
convPackage[filename, packagename, Hold[names...], typeOnlyFlg->True,templateGenFlg->True] outputs only typed definitions if typeonlyflg is True. \n
convPackage[$Output, packagename, Hold[names...]] outputs on stdoutput. \n
Converts into MathCode internal form all typed definitions and prints them on the file, then closes the file.\n
convPackage[filename, \"packagename\"] generates code for all names in the \"packagename`\" context."; 

Options[convPackage] = {
  typeOnly->True,
  templateGen->True,
  mathHeader->True
};

convPackage::error="Conversion failed in function `1`";

convPackage[file:(_String | (List[__OutputStream] | _OutputStream)),
            packagename:_String, funclist:(_Hold | Null):Null,
            popts:({___Rule}|Null):Null, opts___Rule]   :=    Module[ {
   stream, namelist,
   typeOnlyFlg,templateGenFlg,
   templfilename, templStream, pos,
   mathHeaderFlg, (* True if a .mh (Mathematica header) file should be
   					generated *)
   mathHeaderfilename, mathHeaderStream, foreignsymbols,
   localnames, nonlocalpkgs, extnames={}
  }, 
  
  (* First initialize option Flg variables created by Module *)
  ReleaseHold[Hold[
    typeOnlyFlg=typeOnly,
    templateGenFlg=templateGen,
    mathHeaderFlg=mathHeader
    ] /. {opts} /. Options[convPackage]
  ];
  
  translationErrorFlg = False;
  If[StringQ[file],
    stream = OpenWrite[file, FormatType->StandardForm, 
                     DOSTextFormat->False, PageWidth -> Infinity];
    templfilename = mathHeaderfilename = file;
    templStream = mathHeaderStream = Null;
  ,
    stream = file;  (* file already open, usually $Output; just use it *)
    templfilename = mathHeaderfilename = Null;
    templStream = mathHeaderStream = 
    	If[file === $Output, file, Null];
  ];
  
  If[!StringQ[file] && file=!=$Output, mathHeaderFlg=templateGenFlg=False];
  
  (* Make init function for global variables *)
  (* mkInitPackageFunc[packagename]; *) (* Moved to compiler.m *)
  
  templateGenFlg=False;(* This file is not needed; generated always by om.exe *)
  
  If[templateGenFlg,
    If[StringQ[file],
      pos = StringPosition[file,"."];
      If[pos=!={},
        (* create file.tm filename  from file.xx name *)
        templfilename = StringTake[file,{1,pos[[1,1]]-1}]<>".tm"
      , 
        (* just append .tm *)
        templfilename = file <> ".tm"
      ];
      templStream = OpenWrite[templfilename, FormatType->StandardForm, 
                     DOSTextFormat->True, PageWidth -> Infinity];
      (* Write package header into the template file. JG *)
      Write[templStream,":Evaluate: BeginPackage[\"",
      				    packagename,
      				    "`\"];"
      ];
      Write[templStream]
    ]
  ,
    templStream = Null;
  ];
  
  If[funclist===Null,
  		(* convert list of name strings to list of Hold[symbname] *) 
  		namelist = Map[HoldSymbol, Names[StringJoin[packagename, "`*"]]]
  	,
  		namelist = List @@ (Hold /@ funclist)
  ];
  

  localnames = Select[namelist,(Context@@ #)===(packagename<>"`")&];
  extnames = Complement[namelist, localnames];
  
  If[mathHeaderFlg,
    If[StringQ[file],
      pos = StringPosition[file,"."];
      If[pos=!={},
        (* create file.mh filename  from file.xx name *)
        mathHeaderfilename = StringTake[file,{1,pos[[1,1]]-1}]<>".mh"
      , 
        (* just append .mh *)
        mathHeaderfilename = file <> ".mh"
      ];
      mathHeaderStream = OpenWrite[mathHeaderfilename,
      					FormatType->StandardForm, 
                     DOSTextFormat->True, PageWidth -> Infinity];

      (* This produces the Math Header file *)
      MathCodeCommands`createMathHeader[mathHeaderStream, packagename,
      		removeHold[Hold @@ localnames],popts];
	
	  (* Put the external function that are included in the namelist into
	  another section in the MathHeader file. This to support the EnableMathLinkFunctions
	  option since those function are going to be part of namelist, even though they are
	  not belonging to the current package. *)
	 If[Length[extnames]>0,
	 	Write[mathHeaderStream];
	 	Write[mathHeaderStream, "(* The following package definitions are for external functions that are connected via MathLink when using InstallCode. *)"];
	 	
	 	nonlocalpkgs = Union[ Apply[Context, extnames, {1}]];
      	Function[cntx, MathCodeCommands`createMathHeader[mathHeaderStream,
      		 StringDrop[cntx,-1],
      		removeHold[Hold @@ Select[extnames,(Context@@#)===cntx&]  ]]]
      		 /@ nonlocalpkgs;
      ];
      
      Close[mathHeaderStream]
    ]
  ];
  
  
  Write[stream, "model ", packagename, ";" "\n"]; 
  Write[stream, "  packages \"MathCode`\";\n"];
  
	(* Collect all symbols defined in other contexts, i.e., outside
		"packagename`".												*)
  
  foreignsymbols = getPackageForeignSymbols[localnames, packagename];
  
  (* Interpolating functions exists the external interpolator must be included. -JG *)
  If[MathCodeCommands`mc$$InterpolatingFunctions=!={},
  		foreignsymbols = Union[Append[foreignsymbols, Hold[InterpolationTools`RBInterp]]]
  ];
  
 (* Write external functions first *)
  
	(* Create a definition of foreign symbols with right hand side
	   replace by an ExternalFunction[] expression, and let the normal
	   conversion (defConv) interprete these to the standard extern
	   info format for omath4 *)
  Scan[defConv[stream,
  	makeForeignDefinition[#1],True,templStream]&, Union[foreignsymbols,extnames]];
  
  If[templateGenFlg,
  		Write[templStream];
  		Write[templStream, ":Evaluate: EndPackage[]"];
  		Close[templStream]
  ];
  
  Write[stream]; (* Put an empty line *)
  
 Scan[
  	If[
  		Catch[
  			defConv[stream,
  			getDefinition[#1,typeOnlyFlg],
  			True,
  			templStream]
  		] === $Failed, 
  		Message[convPackage::error, Apply[HoldForm,#1]];
  		If[templateGenFlg, Close[templStream]];
    	If[StringQ[file], Close[stream]];
  		Throw[$Failed]
  	]&, localnames];
  		

  
  If[StringQ[file], Close[stream]]; 
]; 

EndFunction[]; (* convPackage *)





(* defConv  - convert definition to Omath4 format and output to file *)

BeginFunction[defConv];

defConv::usage = 
"defConv[file,Hold[definition], optcontext,templStream] writes converted definition on file in MathCode internal format. Optionally, if templStream is not Null or absent,
writes a Mathlink template for a function definition onto the same file ending with .tm \n
 defConv[Hold[definition]] writes converted definition on standard output $Output. 
\n
defConv[file,{Hold[def1],Hold[def2]}] ... same, but for a list of
definitions. \n
The third argument optcontext is optional. If True, sets printing context
to local private for definitions and to the class context for classes.
If False, sets no printing context. If a string, uses that to set the
printing context. \n
The fourth argument templStream is optional. If not Null, produces and
prints a MathLink template on templStream. \n
Functions and global variable definitions need to be converted
for the purpose of later code generation. \n
There are several classes of definitions: \n
(0)  type var; \n
(0b) type {var1,var2,...} \n
(1)  type var = expr; \n
(2)  type var := expr; \n
(3) (type1,type2...->ftype) f[args] = expr; \n
(4) (type1,type2...->ftype) f[args] := expr; \n
type of signature of definitions are stored in mc$$Typeinfo \n
(5) Attributes[name] := {attr1,attr2,...} \n
(6) definitions of UpValues. - not implemented \n
(7) definitions of parameterized names. e.g. Real foo[a] = \n
(8) Subscripted names, e.g. Subscript[a,b] = - not yet implemented \n
(9) Conditional defs are not yet implemented, e.g. \n
    SinFun6[x_,y_ /; y>5] := Sin[x,y] /; x>y  \n
(10) Class[...], Instance[...] \n
(11) Var[...] -- Var declarator that may occur within a class \n

Note: If Pattern occurs within the parameter list, "<> (* --still valid? *)
"as in f[x_] or f[x:Foo], then the
parameter list will be converted to typed form, otherwise not.
There must also be some parameter types available, e.g.
in a signature like {Real}->Real. \n

({Real}->Real) foo[x_] := ...
(Real->Real) foo[x_] := ...  (same as above)
({}->Real) foo[] := ...
({}->Real) foo := ...      this is also a parameterless function)
Real foo = ...             variable name
Real foo[a] = ...          parameterized variable name
Real Subscript[a,b] =  ... subscripted variable

There can also be prefixes like Parameter, Virtual, Flow, etc. before
definitions.
";


(* Error messages *)

(* Most of these error messages are emitted by functions called by defConv *)

(* Note: error message names are strings even if written without quotes, and thus has no context mark *)

defConv::wrongbody =  
"Error: Wrong  structure of body in function `1`, with body:\n`2`";

defConv::wrongfuncparams =  "Error: The number \
of arguments differs from the number of parameter types. \
Function head: `1`\n Parameter  types: `2`";

defConv::missingpartype = 
"Missing function parameter types for function `1` in its type signature: `2`";

defConv::untypedlocalvars = 
"Warning: Untyped local variable(s): `1` in function with head `2`. Real type(s) assumed";

defConv::nullsemi =
"Error: missing semicolon after the last statement in the body of Null-typed function `1`";


(* No file argument - use $Output *)
defConv[definition_] := defConv[$Output,definition,True,Null];


(* multiple def rules for same definition *)
defConv[file_, {def1_Hold, defrest___Hold}, optcontext_:True, templStream_:Null] := (
  defConv[file, def1, optcontext, templStream];
  defConv[file, {defrest}, optcontext, templStream]
);

(* do nothing - no definitions *)
defConv[file_, {}, optcontext_:True, templStream_:Null] := Null;
defConv[file_, Null, optcontext_:True, templStream_:Null] := Null;
defConv[file_, Hold[Null], optcontext_:True, templStream_:Null] := Null;

(* several conditional rules for the same definition *)
(* the same head, but possibly different bodies and conditions for
 * each rule *)
defConv[file_, defs: {Hold[hd_ := _ /; _ ]..} ,optcontext_:True, templStream_:Null] := 
  conditionsConv[file, defs]; (* ??OBS Not implemented yet *)
  

  
(* Handle Class, Partial Class, Type, Partial Type, etc... definitions.
   Set up for eliminating classname context prefix when outputting
   converted class body. Eliminate Partial prefix.
   ??OBS need to be changed later, when/if Private names are used within
   classes.  Right NOW:  do not emit any class code for code generation.
 *)
(*	No support for Modelica in present version *)
(*
defConv[file_, 
        def: (
          Hold[(Class|Instance|Model|Type|RecordType|BlockClass|Connector
               )  [f_[args___]; body___]]     |
          Hold[(Class|Instance|Model|Type|RecordType|BlockClass|Connector
               )  [f_ ; body___]]             |
          Hold[(Class|Instance|Model|Type|RecordType|BlockClass|Connector
               )  [f_ = body___]]             |
          Hold[Partial (Class|Instance|Model|Type|RecordType|BlockClass|Connector
               )  [f_[args___]; body___]]     |
          Hold[Partial (Class|Instance|Model|Type|RecordType|BlockClass|Connector
               )  [f_ ; body___]]             |
          Hold[Partial (Class|Instance|Model|Type|RecordType|BlockClass|Connector
               )  [f_ = body___]] 
              ),
         optcontext_:True,
         templStream_:Null] :=  (
  Which[
    optcontext===True,
      Begin[StringJoin[findContextOf[f],SymbolName[f],"`"]], (* set context *)
    optcontext===False,
      Null, (* do nothing *)
    True,
      Begin[optcontext]
  ];
  (*** Right now, do not emit any code from classes - commented out.
   defConv2[file, Null, def, templStream];  (* perform the conversion *)
  ***)  
  (* Class and Instance adds nothing to template file, except member functions *)
  If[optcontext =!= False, End[]]; (* restore context *)
);              
*)

(* Typed functions or variables. Was set up for Private prefix elimination (not needed anymore -WE) *)
defConv[file_, 
        def: (
              Hold[hd1_ := body_]   |
              Hold[hd1_ = body_]    |
              Hold[hd1_]            
              ),
        optcontextIn_:True,
        templStream_:Null] :=  Module[{
  def2,htype,optcontext:=optcontextIn,packList
},

  def2 = standardizeTypes[def];
 
  htype=Replace[def2, {
   (Hold[$$Decl[_, atype_, hd_] := _ ]  |
    Hold[$$Decl[_, atype_, hd_] = _ ]  |
    Hold[$$Decl[_, atype_, hd_]] )  :> (   
        
      If[Hold[atype]===Hold[AnyType], 
                                     (* then get type if untyped, i.e. AnyType *)
        Replace[getTypeInfo[hd],  $$Decl[_,atype1_] :> Hold[atype1]],
        Hold[atype]                  (* else return Hold[atype] *)
      ]
    )
  }];
  
  
  defConv2[file, htype, def2, templStream];  (* Output converted function/var code *)

 

];              

     
EndFunction[]; (* defConv *)



(* defConv2 *)

(* Help function to defconv *)
(* Note: defConv2 is doing the actual work for defConv, but with $Context rebound *)

BeginFunction[defConv2];

(**** OBS Do not convert classes right now. Commented Out.
(* Class or Instance definition *)
defConv2[file_, Null, def:(Hold[(Class|Instance)[___]]), templStream_:Null] := (
  classConv[file, def, templStream];
);
****)

(* Variable or function definition, or SetAttribute *)

defConv2[file_, htype_Hold, Hold[$$Decl[_, _, hd_ ] = expr_], templStream_:Null] := 
   funcConv[file, htype, Hold[hd], "=", Hold[expr], templStream];

defConv2[file_, htype_Hold, Hold[$$Decl[_, _, hd_] := expr_], templStream_:Null] := 
   funcConv[file, htype, Hold[hd], ":=", Hold[expr], templStream];
   
(* Attribute - emit Attributes *)   
defConv2[file_, htype_Hold, Hold[Attributes[name_] = attrlist_], 
         templStream_:Null] := (
  If[Not[attrlist === {Temporary}],
    Write[file, HoldForm[Attributes[name] = attrlist], ";"];
    Write[file]
  ]
);

(* Several variables for one type, e.g.:   Real {a,b,c}  *)
defConv2[file_, htype_Hold, Hold[$$Decl[_, _, {}]], templStream_:Null] := Null; 

defConv2[file_, htype_Hold, Hold[$$Decl[prefix_, atype_, {hd1_, hdrest___}]],
         templStream_:Null] := (
  defConv2[file, htype, Hold[$$Decl[prefix, atype, hd1]]];
  defConv2[file, htype, Hold[$$Decl[prefix, atype, {hdrest}]]];
);

(* Just a single variable symbol - emit unchanged  if not temporary *)
defConv2[file_, htype_Hold, Hold[$$Decl[_, _, hd_]], templStream_:Null] := (
  If[Not[Head[Unevaluated[hd]]===Symbol &&
         Attributes[hd] === {Temporary}],
    Write[file,
          (* substitute in function parameter and result types *) 
          ToStringContextFree[ replaceFuncTypes[  
              Replace[htype,Null->""]
            ]/.Hold->HoldForm ]<>
          " "<> ToStringContextFree[HoldForm[hd]]<>";"]; 
    Write[file]
  ];
);

(* Empty definition - emit nothing *)
defConv2[file_, htype_, Hold[], templStream_:Null] := Null;

EndFunction[]; (* defConv2 *)

























































(* mkArgSubstList creates a substitution list to P$ context prefix for 
  parameter names from Mathematica function parameter list *)

(* Ex:  mkArgSubstList[Hold[fum`x_,Global`y_Integer]]  returns
 *       {HoldPattern[fum`x]:>P$`x, HoldPattern[Global`y]:>P$`y}
 *)



BeginFunction[mkArgSubstList,mkArgSubstRule]

mkArgSubstList[Hold[params___]] := mkArgSubstList[Hold[params],Hold[]];

mkArgSubstList[Hold[], Hold[argnames___]] := mkArgSubstRule[Unevaluated[{argnames}]];

mkArgSubstList[Hold[Verbatim[Pattern][param1_,_], rest___], Hold[argnames___]] := (
  mkArgSubstList[Hold[rest], Hold[argnames,param1]]
);

SetAttributes[mkArgSubstRule, Listable];

mkArgSubstRule[x_Symbol] :=
   (HoldPattern[x] :> 
      Evaluate[ToExpression["P$`"<>SymbolName[Unevaluated[x]]]]);

EndFunction[];







(* conditionsConv  ?? Implementation not yet completed *)

(* convert set of conditional rules to a Which-statement *)



BeginFunction[conditionsConv, 
      bodyC2, 
      bodyC3
      ];
    

conditionsConv::usage = 
"conditionsConv[conddefs] converts a list conddefs of conditional definition 
rules which all have the same head but may have different bodies and 
condition predicates. The condition predicates and bodies are merged into a  Which-statement. \n
Example: 
conditionsConv[{Hold[f[x_] := x+1 /; x>0], Hold[f[x_] := x-1 /; x<0]}] gives the result: \n
Hold[ f[x_] := Which[x>0, x+1, x<0, x-1]]";


conditionsConv[condrules: List[Hold[hd1_ := body1_ /; pred1_ ], 
                           restrules___]]          := 
  bodyC2[Hold[hd1], condrules, Hold[], Hold[]];


(* Accumulate bodies and predicates *)
bodyC2[hd_Hold, {Hold[ _ := body1_ /; pred1_ ], restrules___},
       Hold[bodies___], Hold[predicates___] ] := 
  bodyC2[hd, 
         {restrules}, 
         Hold[body1, bodies], 
         Hold[pred1, predicates]
  ];

(* We have collected all bodies and predicates. Call bodyC3 to
 * build the new Which-body 
 *)
bodyC2[hd_Hold, {}, hbodies_Hold, hpredicates_Hold] := 
  bodyC3[hd, hbodies, hpredicates, Hold[]];


(* Accumulate pairs of predicate,body in whichlst *)  
bodyC3[hd_Hold, 
       Hold[body1_, bodies___], 
       Hold[pred1_, predicates___],
       Hold[whichlst___] ] :=
  bodyC3[hd, Hold[bodies], Hold[predicates],
         Hold[pred1, body1, whichlst] ];
         
(* Here:  return the completed definition with Which-body *)  
bodyC3[Hold[hd1_], Hold[], Hold[], Hold[whichlst___]] :=
  Hold[ hd1 := Which[whichlst]];
  

EndFunction[]; (* conditionsConv, bodyC2, bodyC3 *)















(* funcConv  - convert a function/variable definition*)

BeginFunction[funcConv];

funcConv::usage = 
"funcConv[file,type,untypedhead,asgstr,funcbody,templStream] 
writes converted function or variable 
definition on file.
Example: for an untyped definition f[a_,b_,c_] := body, this becomes:
funcConv[$Output, Null, Hold[f], Hold[f[a_,b_,c_]], \":=\", body].\n
If templStream not Null, also generate Mathlink template.
Also: funcConv[funcrule] or funcConv[file,funcrule], where funcrule is a :> rule 
obtained from DownValues"; 


(* To handle a rule to be converted to standard output *)

funcConv[defrule_] := funcConv[$Output,defrule];


(* To handle a function def stored in downvalue rule format - almost never used *)
funcConv[file_, hpattern_[hd_] :> body_] := 
        funcConv[file, Replace[getTypeInfo[hd], $$Decl[_,atype_]:> Hold[atype]],
                       Hold[hd], ":=", Hold[body] ];


(* The actual funcConv function,  usually for typed definitions *)
funcConv[file_, ftype_Hold, Hold[hd_], asgstr_,
         Hold[body_], templStream_:Null ]:=
  Module[{
   ftype3,
   funcname
  },
 
  
  (* Emit header lacking formal parameters *)
  If[Position[Hold[hd],Pattern]==={}
  ,
   
    (* No Pattern, i.e. no formal parameters in hd, e.g. x_ or x:... *)
    ftype3 = Replace[ftype, {
      Null  :>  "",                    (* hd has no type *)
      Hold[{}->type1_] :> Hold[type1]  (* hd is funchd with no args *)
    }];
    
	(* To prevent that context is written out before the function name, JG *)
	funcname = Hold[hd] /. Hold[f_[args___]] :> SymbolName[f];
	
	 
	(* Assume that if asgstr is "=", no global variable initialization should
     * be emitted since, such inits are collected in the initfunction.
     *)
    If[asgstr==="=",
    	(* Assume is is a global variable *)
    	WriteString[file, 
     	       ToStringContextFree[replaceFuncTypes[ftype3]/.Hold->HoldForm],
      	      " ", 
      	        ToStringContextFree[HoldForm[hd]], (* WHAT to use here - hd (PF variant) or ReplacePart(JG variant) ?-WE.
      	        I added even more security to ensure the abcense of contexts *)
      	      If[ MatchQ[ Hold[body], Hold[ExternalVariable[___]]],
    			(* External Variable *)
    			" := "
    		  ,
    		  	(* Local Variable *)
    		  	";"
    		 ]
      	];
      	      
        (* If external variable the external info should written *)
        If[ MatchQ[ Hold[body], Hold[ExternalVariable[___]]],
    		bodyConvExternal[file, ftype, Hold[hd], Hold[body]]];
    , 
	 
	 
	
	 (* A function without parameters *)
    WriteString[file, 
          ToStringContextFree[ replaceFuncTypes[ftype3]/.Hold->HoldForm],
          " ",ToStringContextFree@ ReplacePart[HoldForm[hd],funcname,{1,0}], 
          " ", asgstr, " " 
    ];
(*    End[];
    $ContextPath = oldContextPath;*)
    
    bodyConv[file, ftype, Hold[hd], Hold[body]]
    
    ];
    
    
  ,
  
  
  
  (* otherwise Emit header with typeconverted formal parameters *)

(*    cntx = findContextOf[hd];
    oldContextPath = $ContextPath;
    $ContextPath = Prepend[$ContextPath, cntx];
    Begin[cntx<>"`Private`"];*)

    WriteString[file, 
      ToStringContextFree[ headConv[Hold[hd], ftype]/. Hold->HoldForm ],
      " ", asgstr, " "
    ];
(*    End[];
    $ContextPath = oldContextPath;*)
    
    bodyConv[file, ftype, Hold[hd], Hold[body]];
    If[templStream =!= Null,           (* Output MathLink function template *)
      Replace[ftype, (
        Hold[ftype2_] :> (
          outFuncMathLinkTempl[templStream, Hold[ftype2 hd := body]] 
          )
      )]
    ]
  ];
  Write[file];
 ]; (* funcConv *)
    
EndFunction[]; (* funcConv *)











(* replaceFuncTypes, replaceDeclTypes - final type replacement for Omath4 code *)
(*  replaceFuncTypes;            - replace function argument and result types *)
(*  replaceDeclTypes;            - replace types in local or global declarations *)

BeginFunction[replaceFuncTypes,replaceDeclTypes];
    
replaceFuncTypes::usage =    
"replaceFuncTypes[intypeexpr] replaces names of basic types in intypeexpr.
Example: replaceFuncTypes[Hold[{Real,Integer,Boolean}->Real] gives 
Hold[{real,int,bool}->real].
Also replaces ArrayOf[real,{10,10}]  to real array[10,10], or
 ArrayOf[ArrayOf[int,{n_,_}],{20}]  to int array[0,0][20] 
 These replacements are currently not evaluation protected,
 which is not needed now.";


(* Replace types in signatures, i.e. function parameter or result types *)
(* Real->real,Integer->int, etc... *)
replaceFuncTypes[intypeexpr_] := (
  intypeexpr /. {
    Real  :> real,
    Integer  :> int,
    Boolean  :> bool,
    Complex :> complex,
    String :> String,
    Null  :> {},
    (Verbatim[_] | Verbatim[Pattern][_Symbol,Verbatim[_]]) :> 0  (*{n_,m_}->{0,0}*)
  } //. {
    ArrayOf[atype_,{dims___}] :> (atype array[dims])
  }
 );      

replaceDeclTypes::usage =    
"replaceDeclTypes[intypeexpr] replaces names of basic types in intypeexpr, which
is a held list of declarations
";

(* Replace types in global or local declaration lists *)
(* Real x_ ->real x, Integer y_->int y,... *)
(* this is different from replaceFuncTypes in handling type prefixes of variables *)
replaceDeclTypes[intypeexpr_] := (
  intypeexpr /. {
    Real :> real,
    Integer :> int,
    Boolean :> bool,
    Complex :> complex,
    String :> String,
    (Verbatim[_] | Verbatim[Pattern][_Symbol,Verbatim[_]]) :> 0 (*{n_,m_}->{0,0}*)
  } //. {
    Times[pre___,ArrayOf[atype_,{dims___}],x__] :> Times[pre,atype,array[dims],x]
  } //. {
    HoldPattern[Times[Times[x__]]] :> Times[x]
  }
 );      

EndFunction[];















BeginFunction[mkMCIBody,mkMCIBlock];

mkMCIBody::usage="
mkMCIBody[bodyhold] converts body, including zero or more nested blocks,
into MathCode internal format. Directly blocks are flattened. \n 
Example: \n
mkMCIBody[Hold[Module[{Real bb, Integer aa;}, With[{Real cc}, cc=aa+bb]]]] \n
returns Hold[Module[{real bb, int aa, real cc}, cc=aa+bb]]
";

mkMCIBody[bodyhold_Hold] := Module[{
  bodyhold2
 },
  (* recognize nested Module[{locals},With[{locals},...]] and flatten out. *)
  bodyhold2 = bodyhold /. {
    HoldPattern[(Module|Block|With)[
                  {locals1___},(Module|Block|With)[{locals2___},body_]] ] :>
    Module[{locals1,locals2},body]
  };
  
  (* Perform a sequance of different transformations *)
  bodyhold2 = bodyPass1[bodyhold2];
  
  (* Perform conversion to Omath4 format for each remaining block *)
  ReplaceAllHoldFunc[bodyhold2, 
                     HoldPattern[(Module|Block|With)[{locals___},body_]], 
                     mkMCIBlock]
];


mkMCIBlock[Hold[(bhead:(Module|Block|With))[{locals___},body_]]] := (
  (* Body header is Module[], Block[] or With[] *)
      Replace[replaceDeclTypes[mkElaboratedVars[removeSemiColon[Hold[locals]],
                staticDecl->False,keepTypes->True,
                constDecl->False,arrayAllocInit->False (* AllocInit fixed by C++ *)
                              ]], { 
        Hold[locals2___] :>  (
          Hold[bhead[{locals2},body]]
        )
      }]
);

EndFunction[];









BeginFunction[bodyPass1];

bodyPass1::usage = "bodyPass1[Hold[body]] performs several transformations on the body.";
bodyPass1::converror = "Could not convert `1` to Do[] loop; this function call can be used in MathCode in the right-hand-side of assignment only.";

mc$StandardRules = {
	(* Note! These transformations are only correct when used as statements *)
	HoldPattern[Increment[x_]] :> (x = x+1),
	HoldPattern[Decrement[x_]] :> (x = x-1),
	HoldPattern[PreIncrement[x_]] :> (x = x+1),
	HoldPattern[PreDecrement[x_]] :> (x = x-1),
	
	HoldPattern[AddTo[x_, dx_]] :> (x = x+dx),
	HoldPattern[SubtractFrom[x_, dx_]] :> (x = x - dx),
	
	HoldPattern[SameQ] :> Equal,
	HoldPattern[UnsameQ] :> Unequal,
	
	(* Remove trivial multiplications and powers *)
	(* HoldPattern[Plus[x_, Times[-1,y_]]] :> Minus[x,y], *)
	HoldPattern[Times[-1,y_]] :> Minus[y],
	HoldPattern[Times[x_, Power[y_,-1]]] :> Divide[x,y],
	HoldPattern[Power[y_,-1]] :> Divide[1,y],
	
	(* Fix to make ArcCoth work for matrices *)
	HoldPattern[ArcCoth[x_]] :> ArcTanh[1/x],
	
	(* Fix to make Quotient work for integer values *)
	HoldPattern[Quotient[x_,y_]] :> Floor[N[x]/y],
	
	(* DiagonalMatrix *)
    (* DiagonalMatrix can only be used in the left hand side of an assignment. *)
	HoldPattern[(Set|SetDelayed)[var_, DiagonalMatrix[vec_]]] :>
		(
			setshape[var,Length[vec],Length[vec]];
			var = var*0;
			Do[
				var[[mctmp,mctmp]] = vec[[mctmp]],
				{mctmp,Length[vec]}
			]
		),
	HoldPattern[DiagonalMatrix[x_]] :>
		Throw[Message[bodyPass1::converror, HoldForm["DiagonalMatrix"[x]]];$Failed],
		
	(* IdentityMatrix *)
	(* IdentityMatrix can only be used in the left hand side of an assignment. *)
	HoldPattern[(Set|SetDelayed)[var_, IdentityMatrix[n_]]] :>
		(
			setshape[var, n, n];
			var = var*0;
			Do[
				var[[mctmp,mctmp]] = 1,
				{mctmp,n}
			]
		),
	HoldPattern[IdentityMatrix[x_]] :>
		Throw[Message[bodyPass1::converror,HoldForm["IdentityMatrix"[x]]];$Failed],
		
	(* Range *)
	(* Range can only be used in the left hand side of an assignment. *)
	HoldPattern[(Set|SetDelayed)[var_, Range[start_]]] :>
		(var = Table[mctmp,{mctmp,start}]),
	HoldPattern[(Set|SetDelayed)[var_, Range[start_,stop_]]] :>
		(var = Table[mctmp,{mctmp,start,stop}]),
	HoldPattern[(Set|SetDelayed)[var_, Range[start_,stop_,step_]]] :>
		(var = Table[mctmp,{mctmp,start,stop,step}]),
		
	HoldPattern[Range[x__]] :>
		Throw[Message[bodyPass1::converror,HoldForm["Range"[x]]];$Failed],
		
	(* OuterProduct *)
	HoldPattern[Outer[Times,m1_,m2_]] :> OuterProduct[m1,m2]
	};

bodyPass1[Hold[body_]] := Module[{code = Hold[body]},
  
  (* Here is the place to put macros *)
  If[!ValueQ[mc$$MacroRules], mc$$MacroRules={}];
  code = code //.  mc$$MacroRules;
  
  (* Make the interpolation object replacement here. -JG *)
  If[!ValueQ[mc$$InterpMacroRules],mc$$InterpMacroRules={}];
  code = code //. mc$$InterpMacroRules; (*Added by AK*)
  
  (* Apply the standard rules *)
  code = code //. mc$StandardRules;
  
  (* Early errors trap *)
  Cases[code, HoldPattern[thrw_Throw]:>thrw, {1,Infinity}];
  
  (* Sum conversion *)
  code = code //.
  		HoldPattern[(Set|SetDelayed)[var_,Sum[expr_,iters__]]]
  		:> (var = 0; Do[var = var + expr, iters]);
  		
  (* Product conversion *)
  code = code //.
  		HoldPattern[(Set|SetDelayed)[var_,Product[expr_,iters__]]]
  		:> (var = 1; Do[var = var * expr, iters]);
  		
  code = code //.
  		HoldPattern[Product[x__]]:>	
  		Throw[Message[bodyPass1::converror,HoldForm["Product"[x]]];$Failed];

  code = code //.
  		HoldPattern[Sum[x__]]:>	
  		Throw[Message[bodyPass1::converror,HoldForm["Sum"[x]]];$Failed];
  		
  (* Early errors trap 2 *)
  Cases[code, HoldPattern[thrw_Throw]:>thrw, {1,Infinity}]; 			
  
  (* Move non simple initializers in local variable declarations from
     the declaration to beginning of the code *)
  code = localInitConv[code];
  
  (* Map conversion *)
  code = ReplaceAllHoldFuncRepeated[
  					code,
  					HoldPattern[Map[x___]] /; FreeQ[Hold[x],(Map|Apply)],
  					ConvMap
  		]; 
  
  (* Apply conversion | Apply[x__]*)
  code = ReplaceAllHoldFuncRepeated[
  					code,
  					HoldPattern[(((Set|SetDelayed)[_,Apply[__]])  )]
  					,
  					ConvApply
  		];
  		
  code = ReplaceAllHoldFuncRepeated[
  					code,
  					HoldPattern[( Apply[x__] )]
  					 ,
  					ConvApply
  		];
 
   (* Here is the place to put rules for list constructors *)
  (* This is solved in the code converter instead *)
  (* code = listConstructor[code]; *)
  
  (* Here is one place to flatten out all Module, Block and With *)
  code = flattenBlock[code];

  (* Move nested CompoundExpressions outside expressions,
  	This requires that the CompoundExpressions are side effect free *)
  code = moveCompoundExpr[code];
  
  
  (* Perform transformation of Table,Do,Array into For loops *)
  code = replaceIterators[code];
  
  (* A second look for nested blocks and compound expressions*)
  code = flattenBlock[code];
  code = moveCompoundExpr[code];
  
  (* Find error messages that have been put into the code.
     These messages are arguments to Throw expressions.
     The evaluated Throw must be catched by the caller. *)
  Cases[code, HoldPattern[thrw_Throw]:>thrw, {1,Infinity}];
  
  (* Return the result *)
  code
];

EndFunction[];

































BeginFunction[findMissplaceCompundExpr];

findMissplaceCompundExpr::usage = "findMissplaceCompundExpr[Hold[body]] returns the position of the first misplaced CompoundExpression. If nothing is found, {} is returned.";

findMissplaceCompundExpr[Hold[body_]] := Module[{pos, exclude},
	(* Compute the positions for all CompoundExpressions not having
	statementpattern as upvalues *)
	pos = Position[Hold[body], 
			HoldPattern[(h_)[___, CompoundExpression[___],___]]
			 /; FreeQ[Hold[h], statementpattern],{1,Infinity}];
			 	
	If[ pos === {},
		{}
	,
		(* Select those pos that is not part of local variable declaration in
			Module, Block, or With *)
		exclude = (Join[#,{1,___}]& /@ Position[Hold[body],
					HoldPattern[(Module|With|Block)[{___},___]]]);
		exclude = If[Length[exclude]>1,
						Alternatives@@ exclude
					,
						Flatten[exclude]
					];
				
		pos = Select[pos, !MatchQ[#,exclude]&];
						
		(* Return pos with the coordinate for the included CompoundExpression
			appended *)
		Join[#,
			Drop[Flatten@ Position[Extract[Hold[body], #, Hold],
				HoldPattern[CompoundExpression[___]],
				{2},1
			], 1]
		]& /@ pos
	]
];

statementpattern = (If|Which|For|While|Do|Module|With|Block|CompoundExpression|Table);
(* Affect from where all compound expressions (except last one) should not be removed *)

EndFunction[];





















BeginFunction[moveCompoundExpr];

moveCompoundExpr::usage = "moveCompoundExpr[Hold[body]] searches for a CompoundExpression that is nested inside expressions. The last part of such a CompoundExpression remains inside the expression, whereas the other parts of the CompoundExpression are moved outside and before the expression to the nearest CompoundExpression, If, Which, For, Do, While Module, With, and Block statement.";

moveCompoundExpr[Hold[body_]] := Module[{code, pos, npos, allbutlast,
										thelast, l, r, m, newbranch, poslist, i},
		code = Hold[body];
		
		While[(poslist=findMissplaceCompundExpr[code]) =!= {},
			
			(* Take off the first and search again. This is
				enough for now but needs to be imroved to gain performance *)
			(*For[i=1, i<=Length[poslist], i++,
				pos = poslist[[i]];*)
				pos = First[poslist];
				(* Divide the parts *)
				{allbutlast, thelast} =
					Replace[Extract[code, pos, Hold],
						Hold[CompoundExpression[l___,r_]] :> {Hold[l], Hold[r]}
					];
			
				(* Search for the closest place to put it *)
				npos = Drop[pos,-1];
				While[!MatchQ[Extract[code,Join[npos,{0}]],
						statementpattern] && npos =!= {},
					npos = Drop[npos,-1]
				];
			
				If[npos === {},
					(* None of the standard control structures were found *)
					code = Apply[CompoundExpression,
						Hold@@ List@ Join[allbutlast, 
							ReplacePart[code, thelast, pos, {1}]],{1}];
				,
					(* Position for the branch that shall be replaced *)
					npos = Join[npos,Take[pos,{Length[npos]+1}]];
					newbranch = Extract[ReplacePart[code, thelast, pos, {1}], npos, Hold];
					(* Put the new branch in together with a first parts of the
					 	CopoundExpression found *)
					code = ReplacePart[code,
								Apply[CompoundExpression,
									Hold@@ List@ Join[allbutlast, newbranch], {1}],
									npos, {1}];
				];
		(*	]; *)
		];
	
		code //. HoldPattern[CompoundExpression[l___,
			CompoundExpression[m___],r___]]:> CompoundExpression[l,m,r]
		];
					
		

EndFunction[];

















BeginFunction[listConstructor, listConstructor2];

listConstructor::usage = "listConstructor[Hold[body]] replaces occurrences of list contructors with a temporary variable assignment.\n
The code converter supports list constructor assignments to typed variables. Here we trap assigment to parts of typed variables.";



listConstructor[Hold[SEARCH[body_]] | Hold[body_]] := 
Module[{pos, code},
	
	code = Hold[body];
	
	(* Mark where to search and list to replace *)
	code = code /. {
			(* Don't replace List which is not list constructors *)
			HoldPattern[(h:(Module|With|Block))[v_List,c___]] /;
				FreeQ[Hold[c],LIST|SEARCH] :> h[v,SEARCH[c]],
			HoldPattern[(h:(Table|Array))[e_,i__]] /;
				FreeQ[Hold[e],LIST|SEARCH] :> h[SEARCH[e],i],
			HoldPattern[(h:(Map|Apply))[f_,e_,i__]] /;
				FreeQ[Hold[e],LIST|SEARCH] :> h[SEARCH[f],SEARCH[e],i],
		
			(* Don't replace assignment of typed variable with constant matrix *)
			HoldPattern[s:((Set|SetDelayed)[_Symbol, m_List])] /;
				(TensorRank[Unevaluated[m]]===Depth[Unevaluated[m]]-1) && 
				(And@@ Flatten[Map[NumberQ, Unevaluated[m],
						{TensorRank[Unevaluated[m]]}]]) :> s,
						
			(* Other lists will be treated more carefully *)
			HoldPattern[l_List] :> LIST[l]
			};
		
	(* Recursively search from SEARCH marks *)
	code = ReplaceAllHoldFunc[code, HoldPattern[SEARCH[___]], listConstructor];
	
	(* Replace the list with variable assignment in a Module *)
	ReplaceAllHoldFunc[code, HoldPattern[LIST[___]], listConstructor2]
];

listConstructor2[Hold[LIST[list_]]] :=
	Module[{tmp, type, dim},
		tmp = Flatten[Map[Head[Unevaluated[#]]&, 
					Unevaluated[list],
					TensorRank[Unevaluated[list]]]
				];
		If[ MatchQ[tmp,{(Integer|Real|Rational|Complex|String)..}],
			(* Normal Matrix *)
			type = 
			If[MatchQ[tmp,{String..}],
			   String,
			   If[ FreeQ[tmp,Complex],
			       If [ FreeQ[tmp,Real|Rational], 
			            Integer, 
			            Real],
			       Complex
			       ]
			];
			
			dim = Dimensions[Unevaluated[list]];
			Return[ ReplacePart[
				Hold[Module[{type mctmp}, mctmp = list; mctmp]],
				type @@ dim, {1,1,1,1}]
			]
		,
			(* Not a normal matrix. Unwrap the list to the rank of TensorRank *)
			{type, dim} = tensorType[list];
			(* This will create the same simple construction as for
				a normal matrix. Have to check if the unwrapping should
				be done in om.exe instead *)
			Return[ ReplacePart[
				Hold[Module[{type mctmp}, mctmp = list; mctmp]],
				type @@ dim, {1,1,1,1}]
			]
		]
	];
		
EndFunction[];























BeginFunction[tensorType,tensorType2];

	tensorType::usage = "tensorType[list] returns a list {type, dim} where type is the type of the elements of the tensor and dim is the dimension.";
	
tensorType::error = "Failed to compute the total type of the list constructor `1`.";
	
SetAttributes[tensorType,HoldAll];
SetAttributes[tensorType2, HoldAll];

tensorType[x_List] := Module[{res = Catch[tensorType2[x]]},
	Print["tensorType ",Hold[x]];
	If[res =!= $Failed,
		res
	,
		Message[tensorType::error,HoldForm[x]];
		Return[$Failed]
	]
];

tensorType2[{}] := {AnyType,{0}};

tensorType2[{e__?NumberQ}] := {
		If[ MatchQ[Unevaluated[{e}],{__Integer}],
		    Integer,
		    If[ MatchQ[Unevaluated[{e}],{(_Real|_Integer|_Rational)..}],
		        Real,
		        Complex
		      ]  
		],
		{Length[Unevaluated[{e}]]}};

tensorType2[e_?NumberQ] := {If[Head[e]===Integer, Integer, Real], {}};

tensorType2[s_Symbol] := Module[{tmp = getTypeInfo[s]},
		If[tmp === Null,
		 	Throw[$Failed]
		 ,
		 	tmp /. {$$Decl[_,ArrayOf[type_, dim_]]:>{type,dim},
						   $$Decl[_,type_] :> {type, {}}}
		]
	];

tensorType2[l_List]:= Module[{res},
	res = tensorType2 /@ Unevaluated[l];
	(* The result should give same dimensions and type but Real has priority*)
	If[(SameQ @@ res[[_,2]]),
		Return[{
		  If[MatchQ[res[[_,1]],{Integer..}], 
		     Integer, 
		     If[MatchQ[res[[_,1]],{(Real|Integer|Rational)..}],
		        Real,
		        Complex
		       ]
		   ]    ,
	   Prepend[res[[1,2]],Length[res]]}]
	,
		Throw[$Failed]
	]
];

EndFunction[];









































BeginFunction[flattenBlock];

flattenBlock::usage = "flattenBlock[Hold[body_]] removes all nested Module, Block or With, and places all the local variables in a single Module on top.";

flattenBlock[Hold[body_]] := Module[
	{localvars, code, stdbody, nvars, ncode, v, c, s, 
	 conflict, namerule, pos, nvarsymb},

	(* Return if there are no blocks in body or if it has a single block
	   on top *)
	If[ (FreeQ[Hold[body],  Module | With | Block] ||
		MatchQ[Hold[body],
			Hold[(Module | With | Block)[{___},c___]]
				/; FreeQ[Hold[c],Module | With | Block]])		
		,
		Return[Hold[body]]
	];
	
	stdbody = Hold[body];
	
	(* If body does not have a Module on top *)
	If[!MatchQ[stdbody, Hold[(Module | With | Block)[__]]],
		stdbody = Hold[Module[{},body]]
	];
	
	(* Store the top variables and code *)
	localvars = Replace[stdbody,
						Hold[(Module | With | Block)[{v___},___]]:> Hold[v]
				];
	code = Replace[stdbody,
					Hold[(Module | With | Block)[{___},c___]] :> Hold[c]
			];
			
	(* Iterate over the nested blocks in body *)
	While[!FreeQ[code, (Module | With | Block)],
	
		(* Extract the nearest block in stdbody *)
		pos = First@ Position[code,
			HoldPattern[(Module | With | Block)[{___},c___]]
				/; FreeQ[Hold[c], Module | With | Block], {0,Infinity}, 1];
		{nvars, ncode} = Extract[ code, pos, Hold] /.
						Hold[(Module | With | Block)[{v___},c___]]:>
							{Hold[v],Hold[c]};
				
		(* Extract local symbol and replace them by unique names *)
		nvarsymb = mkUntypedLocals[nvars] /.
						HoldPattern[(Set|SetDelayed)[s_, _]] :> s;
		namerule = Thread[(List@@ nvarsymb)->(List @@ (Unique /@ nvarsymb))];
				
		(* Update and exchange the local symbols everywhere *)
		localvars = Join[localvars, nvars /. namerule];
		code = ReplacePart[code, ncode /. namerule, pos, {1} ]
	];
		
	ReplacePart[
		ReplacePart[
			Hold[Module[Hold, Hold]], removeHold[Hold@@ {{localvars}}],
			{1,1},{1}
		], code, {1,2}, {1}
	]
]; 

EndFunction[];































BeginFunction[localInitConv];

localInitConv::usage="localInitConv[Hold[Module[{...},...]]] moves all initialization of local variables where the right hand side of the inititalization is not a number or a symbol (single variable), to the begining of the body. This will make it possible to have any kind of expressions as initialization of local variables.";


localInitConv[Hold[(Module|Block|With)[{lvars___},code_]]] := Module[
	{vars = Hold[lvars],
	 pos},
	 
	(* Find the positions of the initializations to move *)
	 pos = Position[vars, HoldPattern[(Set|SetDelayed)[_,e_]]
	 						/; !MatchQ[Unevaluated[e],
	 							_Real | _Integer | _Rational | _Complex | _String |
	 							_Symbol |
	 							HoldPattern[Dimensions[_][[__]]] |
	 							HoldPattern[Dimensions[_]]]
	 		];
	 		
	 (* If no such initializations, return unchanged *)
	 If[Length[pos]===0,
	 	Return[Hold[Module[{lvars},code]]]
	 ];
	 
	 
	 		
	(* Convert, by creating a list of
		{Hold[newlocals], Hold[Moves init statements], Hold[The original code]} *)
	 Replace[
	 	{
	 	(* New local variable declarations *)
	 	Fold[
	 		(* Replace the declarations with the lhs of the initialization *)
	 		ReplacePart[#1, Extract[vars, Append[#2,1], Hold], #2, {1}]&,
	 		vars,
	 		pos
	 	],
	 	(* Init statements *)
	 	Apply[CompoundExpression,
	 		(* Untype the delclarations *)
	 		Hold[Evaluate[mkUntypedLocals[Extract[vars, #, Hold]]& /@ pos]],
	 		{1}
	 	] // removeHold,
	 	(* The original code *)
	 	Hold[code]
	 	}
	 ,
	 	{Hold[nvars__], Hold[stmts_], Hold[c_]} :>
	 	(* Final template *)
	    Hold[Module[{nvars}, stmts; c]]
	]
];

localInitConv[Hold[expr_]] := Hold[expr];

EndFunction[];



















(* bodyConv   - convert body of typed function definition *)

BeginFunction[bodyConv,body2Part,bodyConv2];
   
bodyConv::usage =
"bodyConv[file, ftype, hd,body] will convert and emit the body of a function or variable 
definition. If body is a Module, Block or With which contains local variables,
these variable declarations should be typed according to the usual prefix type format. Nested Module, Block or With may appear insided the body.
Head hd is just passed in case it should be needed for error messages. \n
Function type ftype is passed to check if it is Null.
Example: bodyConv[file,Hold[],Hold[f], Hold[Module[{Real a; Integer b;},a+b+5]]] \n emits: 
Module[{real a, int b}, a+b+5]\n
If body is an ExternalProcedure or ExternalFunction a special internal format is emitted for making a stub function externally.";

body2Part::usage =
"body2part[expr] converts >= 2dim Part expressions like x[[i,j]] to nested part
expressions like x[[i]][[j]]. This is to overcome a deficiency in the
internal form parser";

bodyConv2::usage =
"bodyConv2[file, x] prints x as a semicolon separated list of fullform
expressions if it is a CompoundExpression; otherwise just the FullForm of x.";

(* Convert ExternalProcedure and ExternalFunction bodies to omath4  *)
bodyConv[file_,ftype_Hold, Hold[hd_],
		hbody:Hold[(ExternalProcedure|ExternalFunction)[___]]
		] := bodyConvExternal[file,ftype, Hold[hd],hbody];
		
(* Convert and emit body which is a Module, Block or With *)
bodyConv[file_,ftype_Hold,Hold[hd_],hbody:Hold[(Module | Block | With)[__]]] := 
Module[
  {tmp2},
  (* Two cases in Replace match: 
   * 1) Module/Block/With with local variable declaration,
   * 2) Missing local variables list
   *)
   Replace[mkMCIBody[hbody], {
    (* Normal case: typed local variables *)
    Hold[bhead_[{locals2___},body2_]] :> (
      If[ Not[FreeQ[Hold[locals2], AnyType]],
        (* AnyType present means untyped local variable(s) *)
        (* Emit a warning, assume Real type *)
        tmp2=Position[Hold[locals2], AnyType] /. {x_ ,1} :> {x, 2}; (* positions *)
        tmp2= Thread[Extract[Hold[locals2],tmp2,Hold], Hold]; (* Hold[vars...] *)
        Message[defConv::untypedlocalvars,
                ToString[tmp2 /. Hold->HoldForm],
                ToString[HoldForm[hd]]
        ]            
      ];
      WriteString[file,
            bhead, "[",
            ToStringContextFree[HoldForm[{locals2}]/.(AnyType->real)], "," ];
      bodyConv2[file,bodyFinalTrans[Hold[body2]]];
    ),
    (* Case: e g. missing local variables list *)
    Hold[bhead_[blockbody___]] :> (
      Message[defConv::wrongbody,
              ToString[HoldForm[hd]],
              ToString[HoldForm[bhead[blockbody]]]
      ];
      translationErrorFlg = True;
    )
  }];  
  (* Here check that ends with semicolon if function has return type Null *)
  If[Position[ftype, HoldPattern[_ -> Null], 2] =!= {},
    If[Not[
    MatchQ[hbody, Hold[_[_,CompoundExpression[__,Null]]]]
    ||
    MatchQ[hbody, Hold[_[_,_[_,CompoundExpression[__,Null]]]]]
    ],
      Message[defConv::nullsemi,
              ToString[HoldForm[hd]]
      ]
    ]        
  ];
  Write[file, "];" ]; (* output ending block bracket *)
];

(* Emit body which is not a Module,Block or With. *)
bodyConv[file_,  _Hold, Hold[_], Hold[body_ ]] := Module[{code = Hold[body]},
	code = bodyPass1[code];
	
  If[!MatchQ[code,Hold[(Module|With|Block)[___]]],
    Write[file,"("]; 
    bodyConv2[file, bodyFinalTrans[code]]; 
    Write[file,");"]
  ,
    bodyConv[file, Hold[], Hold[{}], code]
  ]
];

(* Help function to convert e.g. aa[[i,j]] to aa[[i]][[j]] within expr *)
(* This is not needed anymore from Version 0.92  - WE*)
body2Part[expr_] := 
  expr (* //. {HoldPattern[Part[x_,y_,z__]]:> Part[Part[x,y],z]} *);

(* Help function to bodyConv.  Final output. Handle CompoundExpression,
 * since Omath4 does not appreciate several CompoundExpressions. *)

bodyConv2[file_, Hold[CompoundExpression[Null]]] :=
  Write[file, "; "];

bodyConv2[file_, Hold[CompoundExpression[x_, Null]]] :=
  Write[file, ToStringContextFree[body2Part[HoldForm[FullForm[x,NumberMarks->False]]]]<>";"];
  
bodyConv2[file_, Hold[CompoundExpression[x_]]] :=
  Write[file, ToStringContextFree[body2Part[HoldForm[FullForm[x,NumberMarks->False]]]]];

bodyConv2[file_, Hold[CompoundExpression[x_, y__]]] := (
  Write[file, ToStringContextFree[body2Part[HoldForm[FullForm[x,NumberMarks->False]]]]<>";"];
  bodyConv2[file, Hold[CompoundExpression[y]]];
);

bodyConv2[file_, Hold[x_]] :=
  Write[file, ToStringContextFree[body2Part[HoldForm[FullForm[x,NumberMarks->False]]]]];


EndFunction[]; (* bodyConv *)  















(*  bodyFinalTrans;           - Help fn to bodyConv. Apply bodyFinalTransRules *)
(*  bodyFinalTransRules;      - rules applied before final Omath4 bodycode gen *)



BeginFunction[bodyFinalTrans];

bodyFinalTrans::usage="
bodyFinalTrans[hbody] applies a set of transformation rules in bodyFinalTransRules to hbody, which is done by bodyConv2 before emitting the final internal form. For example,
this converts Matlab-like array operations to function calls.
";

bodyFinalTransRules::arctan = "The two-argument variant of ArcTan is only supported on Unix systems. Failed to convert `1`";

bodyFinalTransRules::span = "The three-argument variant of Span is not supported. Rewrite the construct as a loop instead. Failed to convert `1`";

bodyFinalTransRules = { 

(* Special function conversion *)
	(* ArcTan with two arguments corresponds to the atan2 in C *)
	(* The context spec. for ArcTan2 is a workaround for a mysterious
	   bug that turns this symbol to the context $`ArcTan2. -JG *)
	
   HoldPattern[ArcTan[x_,y_]] /; ($SystemID=!="Windows" && $SystemID=!="Windows-x86-64")
        :> ArcTan[x,y],
	(*	:> MathCodeConvSymb`ArcTan2[x,y],*)
	(* Actually OM4 code requires that "ArcTan[x,y]" is generated there -WE *)
	
  (* Used when atan2 was missing in the math libary for Windows *)
	(*HoldPattern[ArcTan[x_,y_]] /; ($SystemID==="Windows"||$SystemID==="Windows-x86-64")
		:> Throw[
			Message[bodyFinalTransRules::arctan, HoldForm["ArcTan"[x,y]]];
			$Failed
		], *)

(* Conversion rules for Take, Drop, Rest, First, Last, Length *)

  (* Take[list, {m,n}] *)
  HoldPattern[Take[x_,{m_,n_}]] :> x[[m|n]],
  (* Take[list, {n}] *)
  HoldPattern[Take[x_,{n_}]] :> x[[n|n]],
  (* Take[list,-n] *)
  HoldPattern[Take[x_,n_Integer?Negative]] :> x[[Length[x]+n+1|_]],
  (* Take[list,n] *)
  HoldPattern[Take[x_,n_]] :> x[[1|n]],

(***  Removed since this is supported in omath4 

  (* Drop[list, {m,b}] *)			(* Join must be implemented in Lightmat *)
  HoldPattern[Drop[x_,{m_,n_}]] :> Join[x[[1|m-1]],x[[n+1|_]]],
  (* Drop[list, {n}] *)
  HoldPattern[Drop[x_,{n_}]] :> Drop[x,{n,n}],
  (* Drop[list,-n] *)
  HoldPattern[Drop[x_,n_Integer?Negative]] :> x[[1|Length[x]+n]],
  (* Drop[list,n] *)
  HoldPattern[Drop[x_,n_]] :> x[[n+1|_]],
 ***) 
  (* Rest[list] *)
  HoldPattern[Rest[x_]] :> x[[2|_]],
  
  (* First *)
  HoldPattern[First[x_]] :> x[[1]],
  
  (* Last *)
  HoldPattern[Last[x_]] :> x[[-1|-1]][[1]],
  
  (* Length *)
 HoldPattern[Length[x_]] :> Dimensions[x][[1]],
 
 (* Span 0 *)
 HoldPattern[Span[]] :> All,

(* Span  x;; has very special use of implicit All symbol:  Span[x,All] *)
 HoldPattern[Span[x_,All]] :> Alternatives[x,-1],

(* Span 2 *)
 HoldPattern[Span[x_,y_]] :> Alternatives[x,y],

 (* Span 3 *)
 HoldPattern[Span[x_,y_,z_]] :> Throw[
  									Message[bodyFinalTransRules::span, HoldForm["Span"[x,y,z]]];
  									$Failed
  								],

  
  (* FromEnd *)
  HoldPattern[Part[x_, l___, FromEnd[i_], r___]] :> Part[x, l, -i|-i, r][[1]],
  (* Error case *)
  HoldPattern[FromEnd[x___]] :> Throw[
  									Message[FromEnd::converror, HoldForm["FromEnd"[x]]];
  									$Failed
  								],

(***  Removed since this is supported in omath4 
(* Assignment versions of the Matlab operators *)

  (* Matlab x(:,j)= or x[[_,{j}]]=. Sets a submatrix which is a column vector *)
    HoldPattern[x_[[Verbatim[_],{j_}]]=rhs_ ] :> setcols[x,j,j,rhs], 
       
  (* Matlab x(:,j1:)= or x[[_,j1|_]]=. Sets submatrix of column j1 to last column *)
  (* Index bound 0 in setcols means dimension size, i.e. upper index bound *)
    HoldPattern[x_[[Verbatim[_],Verbatim[Alternatives][j1_,Verbatim[_]] ]]=rhs_ ] :>
      setcols[x,j1,0,rhs],
    
  (* Matlab x(:,j1:j2)= or x[[_,j1|j2]]=. Sets submatrix of 1 or more columns *)
    HoldPattern[x_[[Verbatim[_],Verbatim[Alternatives][j1_,j2_]]]=rhs_] :>
      setcols[x,j1,j2,rhs],
    
  (* Matlab x(i,:)= or x[[{i},_]]=. Sets a submatrix which is a row vector *)
    HoldPattern[x_[[{i_},Verbatim[_] ]]=rhs_ ] :> setrows[x,i,i,rhs],    
     
  (* Matlab x(i1:,:)= or x[[i1|_,_]=. Sets a submatrix of row i1 to last row *)
    HoldPattern[x_[[Verbatim[Alternatives][i1_,Verbatim[_]],Verbatim[_] ]]=rhs_ ] :>
      setrows[x,i1,0,rhs],
    
  (* Matlab x(i1:i2,:)= or x[[i1|i2,_]=. Sets a submatrix of row i1 to row i2 *)
    HoldPattern[x_[[Verbatim[Alternatives][i1_,i2_],Verbatim[_] ]]=rhs_ ] :>
      setrows[x,i1,i2,rhs],
  
  (* Matlab x(i1:,j1:)= or x[[i1|_,j1|_]]=.  Sets a general submatrix *)
  (* Here 0 represents the size of a dimension, i.e. the upper index bound *)
    HoldPattern[x_[[Verbatim[Alternatives][i1_,
                  Verbatim[_]], Verbatim[Alternatives][j1_,Verbatim[_]] ]] =rhs_ ] :>
      setsubmatrix[x,i1,0,j1,0,rhs],
    
  (* Matlab x(i1:,j1:j2)= or x[[i1|_,j1|j2]]=.  Sets a general submatrix *)
    HoldPattern[x_[[Verbatim[Alternatives][i1_,Verbatim[_]],
                    Verbatim[Alternatives][j1_,j2_] ]]=rhs_ ] :> 
      setsubmatrix[x,i1,0,j1,j2,rhs],
    
  (* Matlab x(i1:i2,j1:)= or x[[i1|i2,j1|_]]=.  Sets a general submatrix *)
    HoldPattern[x_[[Verbatim[Alternatives][i1_,i2_],
                    Verbatim[Alternatives][j1_,Verbatim[_]] ]]=rhs_ ] :>
      setsubmatrix[x,i1,i2,j1,0,rhs],
    
  (* Matlab x(i1:i2,j1:j2)= or x[[i1|i2,j1|j2]]=.  Sets a general submatrix *)
    HoldPattern[x_[[Verbatim[Alternatives][i1_,i2_],
                    Verbatim[Alternatives][j1_,j2_] ]]=rhs_ ] :>
      setsubmatrix[x,i1,i2,j1,j2,rhs],
    
  (* Matlab x(:,j)= or x[[_,j]]=. Sets column j to the contents of a vector *)
    HoldPattern[x_[[Verbatim[_],j_]]=rhs_ ] :> setcol[x,j,rhs], 
       
  (* Matlab x(i,:)= or x[[i,_]]=. Sets row i to the contents of a vector *)
    HoldPattern[x_[[i_,Verbatim[_] ]]=rhs_ ] :> setrow[x,i,rhs],
    
  (* Matlab? v(i1:)=  or v[[i1|_]]=. Sets a subvector of vector v to rhs *)
    HoldPattern[v_[[Verbatim[Alternatives][i1_,Verbatim[_]]]]=rhs_ ] :>
       setsubvec[v,i1,0,rhs],

  (* Matlab? v(i1:i2)=  or v[[i1|i2]]=. Sets a subvector of vector v  to rhs *)
    HoldPattern[v_[[Verbatim[Alternatives][i1_,i2_]]]=rhs_ ] :>
       setsubvec[v,i1,i2,rhs],

  (* Matlab? v(:)=  or v[[_]]=. Sets the whole vector v to rhs *)
    HoldPattern[v_[[Verbatim[_]]]=rhs_ ] :>
       setsubvec[v,1,0,rhs],



(* Value version of Matlab operators. Can appear in right hand side expressions *)

  (* Matlab x(:,j) or x[[_,{j}]]. Produces a submatrix which is a column vector *)
    HoldPattern[x_[[Verbatim[_],{j_}]] ] :> cols[x,j,j], 
       
  (* Matlab x(:,j1:) or x[[_,j1|_]]. Submatrix of column j1 to last column *)
    HoldPattern[x_[[Verbatim[_], Verbatim[Alternatives][j1_,Verbatim[_]] ]] ] :>
      cols[x,j1,0],
    
  (* Matlab x(:,j1:j2) or x[[_,j1|j2]]. Submatrix of 1 or more columns *)
    HoldPattern[x_[[Verbatim[_], Verbatim[Alternatives][j1_,j2_] ]] ] :>
      cols[x,j1,j2],
    
  (* Matlab x(i,:) or x[[{i},_]]. Produces a submatrix which is a row vector *)
    HoldPattern[x_[[{i_},Verbatim[_] ]] ] :> rows[x,i,i],    
     
  (* Matlab x(i1:,:) or x[[i1|_,_]. Submatrix of row i1 to last row *)
    HoldPattern[x_[[Verbatim[Alternatives][i1_,Verbatim[_]],Verbatim[_] ]] ] :>
      rows[x,i1,0],
    
  (* Matlab x(i1:i2,:) or x[[i1|i2,_]. Submatrix of row i1 to row i2 *)
    HoldPattern[x_[[Verbatim[Alternatives][i1_,i2_], Verbatim[_] ]] ] :>
      rows[x,i1,i2],
  
  (* Matlab x(i1:,j1:) or x[[i1|_,j1|_]].  A general submatrix *)
  (* Here 0 represents the size of a dimension, i.e. the upper index bound *)
    HoldPattern[x_[[Verbatim[Alternatives][i1_,Verbatim[_]],
                    Verbatim[Alternatives][j1_,Verbatim[_]] ]] ] :>
      submatrix[x,i1,0,j1,0],
    
  (* Matlab x(i1:,j1:j2) or x[[i1|_,j1|j2]].  A general submatrix *)
    HoldPattern[x_[[Verbatim[Alternatives][i1_,Verbatim[_]],
                    Verbatim[Alternatives][j1_,j2_] ]] ] :>
      submatrix[x,i1,0,j1,j2],
    
  (* Matlab x(i1:i2,j1:) or x[[i1|i2,j1|_]].  A general submatrix *)
    HoldPattern[x_[[Verbatim[Alternatives][i1_,i2_],
                    Verbatim[Alternatives][j1_,Verbatim[_]] ]] ] :>
      submatrix[x,i1,i2,j1,0],
    
  (* Matlab x(i1:i2,j1:j2) or x[[i1|i2,j1|j2]].  A general submatrix *)
    HoldPattern[x_[[Verbatim[Alternatives][i1_,i2_],
                    Verbatim[Alternatives][j1_,j2_] ]] ] :>
      submatrix[x,i1,i2,j1,j2],

  (* Matlab x(:,j) or x[[_,j]]. Produces a vector from column j *)
    HoldPattern[x_[[Verbatim[_],j_]] ] :> col[x,j], 
       
  (* Matlab x(i,:) or x[[i,_]]. Produces a vector from row i *)
    HoldPattern[x_[[i_,Verbatim[_] ]] ] :> row[x,i],
    
  (* Matlab? v(i1:)  or v[[i1|_]]. Extracts a subvector from vector v *)
    HoldPattern[v_[[Verbatim[Alternatives][i1_,Verbatim[_]]]] ] :> subvec[v,i1,0],

  (* Matlab? v(i1:i2)  or v[[i1|i2]]. Extracts a subvector from vector v *)
    HoldPattern[v_[[Verbatim[Alternatives][i1_,i2_]]] ] :> subvec[v,i1,i2],
    
   (* Matlab? v(:)  or v[[_]]. Extracts the whole vector from vector v *)
    HoldPattern[v_[[Verbatim[_]]] ] :> v,   
***)    
    
  (* Remove Trailing Null in For Loops *)
    HoldPattern[For[init_,test_,incr_,CompoundExpression[stmts__,Null]]] :>
      For[init,test,incr,CompoundExpression[stmts]],
      
  (* Translate increment (e.g. i++) in for loop  to (e.g. i=i+1) *)
    HoldPattern[For[init_,test_,(i_Symbol)++,body_]] :>
      For[init,test,(i=i+1),body],
        
  (* Remove Trailing Null in While Loops *)
    HoldPattern[While[test_,CompoundExpression[stmts__,Null]]] :>
      While[test,CompoundExpression[stmts]],  

  (* Translate increment (e.g. i++) in While Loops *)
    HoldPattern[While[test_,CompoundExpression[stm1___,(i_Symbol)++,stm2___]]] :>
      While[test,CompoundExpression[stm1,(i=i+1),stm2]],  

  (* Remove Trailing Null in If statements *)
    HoldPattern[If[test_,true1__;CompoundExpression[trueexpr__,Null],
                         CompoundExpression[falseexpr__] ]] :>
      If[test,true1;CompoundExpression[trueexpr],CompoundExpression[falseexpr]],    

  (* Remove Trailing Null in If statements *)
    HoldPattern[If[test_,CompoundExpression[trueexpr__,Null],
                         CompoundExpression[falseexpr__] ]] :>
      If[test,CompoundExpression[trueexpr],CompoundExpression[falseexpr]],  
        
  (* Remove Trailing Null in If statements *)
    HoldPattern[If[test_,CompoundExpression[trueexpr__],
                         CompoundExpression[falseexpr__,Null] ]] :>
      If[test,CompoundExpression[trueexpr],CompoundExpression[falseexpr]],    

  (* Remove Trailing Null in short If statement *)
    HoldPattern[If[test_,CompoundExpression[trueexpr__,Null] ]] :>
      If[test,CompoundExpression[trueexpr]]
};


bodyFinalTrans[hbody_] := Module[{ code = hbody //. bodyFinalTransRules},
  
  (* Find error messages that have been put into the code.
     These messages are arguments to Throw expressions.
     The evaluated Throw must be catched by the caller. *)
  Cases[code, HoldPattern[thrw_Throw]:>thrw, {1,Infinity}];
  
  (* Return the result *)
  
  code
];

EndFunction[];

























(* headConv *)

BeginFunction[headConv, headConv2, mktypedarg];
    
headConv::usage = 
"headConv[Hold[hd],Hold[typesign]] will convert a function head hd to MathCode internal 
form, e.g.: ftype f[type1 arg1, type2 arg2, ...] using type signature 
typesign. \n
Example: headConv[Hold[f[x_,y_,z_]], Hold[{Real,foo,Real}->Integer]] \n
gives:  Hold[int f[real x_, foo y, real z]]";

(* If type=Null, no conversion *)
headConv[Hold[hd_],Null] := Hold[hd];

(* If missing parameter types for function - error *)
headConv[Hold[f_[args___]], Hold[type1_] /; Part[Hold[type1],1,0]=!=Rule] := (
  Message[defConv::missingpartype,
          ToString[HoldForm[f]], ToString[HoldForm[type1]]];
  translationErrorFlg = True;
);

(* The conversion *)
headConv[Hold[f_[args___]],
      (Hold[{types___} -> ftype_ ] | Hold[types__ -> ftype_]) ] := 
Module[
  {types2=replaceFuncTypes[Hold[types]],
   ftype2=replaceFuncTypes[Hold[ftype]],
   res,
   aFTYPE2,
   func
  },
  (* Check that No args = No parameter types ***)
  If[Length[Hold[args]] =!= Length[types2],
    Message[defConv::wrongfuncparams, 
      ToString[HoldForm[f[args]]], 
      ToString[Map[HoldForm,types2]/.Hold->List] ];
    translationErrorFlg = True;
    Return[Hold[({types} -> ftype) f[args]]];
  ];
  
  (* res is new head of form: ftype f[type1 arg1, type2 arg2, ...] *)
  res = headConv2[Hold[args],types2];
  
 
    (* Add functiontype marker and function head *)
  (* PrecedenceForm introduced here for 1.2 *)
    res = res /. Hold[newargs___]-> (HoldForm[ PrecedenceForm [ aFTYPE2 , 450] * func[newargs]]
 	      /. func-> SymbolName[Unevaluated@ f]);
  								(* To prevent context written out before
  								function name , JG *)
  Return[ReplaceMarker[res,aFTYPE2,ftype2]]
];
    

(* Definitions for headConv2 *)

headConv2[args_,types_] := headConv2[args,types,Hold[]];

(* Flatten removes 1 inner layer of Hold. Prepend together with
 * Reverse of final result might be (in Lisp) more efficient than elementwise
 * Append.
 *)
headConv2[Hold[],Hold[],res_] := removeHold[Reverse[res]];

headConv2[Hold[a1_,ar___],Hold[t1_,tr___],res_] := 
  headConv2[Hold[ar],Hold[tr], 
    Prepend[res, mktypedarg[Hold[a1],Hold[t1]]] ];
  
   

(* mktypedarg[arg,type1] creates a typed argument pair
 * Times[type1,arg1] and puts PrecedenceForm arount arg1
 * to avoid having
 * unnecessary parenthesis around arg1 when printed on file, e.g.
 * print: real x_   instead of:  real (x_)
 *)
  mktypedarg[Hold[arg1_], Hold[type1_]] := 
      Hold[PrecedenceForm[type1,450]*PrecedenceForm[arg1, 450]];

  
  
EndFunction[]; (* headConv, headConv2, mktypedarg *)  























BeginFunction[bodyConvExternal]

bodyConvExternal::usage = 
  "bodyConvExternal[file, Hold[ftype], Hold[hd], ExternalBody] writes the information of the \
external function/procedure and variables to MathCode internal form.";

bodyConvExternal::outuneq = "The number of output types and the number of return values does not match. The number of output types left `1` (in the case of ExternalFunction, the first output type is not included in this list) and Output placeholders `2` does not match. Cannot convert the external function `3`.";

bodyConvExternal::noouttype = "The function `1` is defined (by user or automatically) using
ExternalFunction, which cannot be combined with an empty output type: ({} or Null).";

bodyConvExternal[file_, Hold[ftype_], Hold[hd_],
    hbody:Hold[(
            externaltype:(
                ExternalProcedure|ExternalFunction|ExternalVariable))[
          params___,opts___Rule]]] := 
   Module[{nparams, funcsign,oldparamstyle,tmp,inparams,joined,sq,useInputParamsFlag},

     (* Print["ftype: ", HoldForm[ftype]];
     Print["hd: ",HoldForm[hd]];
     Print["hbody: ",HoldForm[hbody]];*)
     inparams=Cases[HoldForm[hd], Verbatim[Pattern][vvv_, ___] :> Hold[vvv], Infinity];

     (* Make input types always be in a list *)
     funcsign = Replace[Hold[ftype hd],
		   					Hold[((intype_)-> outtype_) hd2_] /;	
		   						!MatchQ[Hold[intype], Hold[List[___]]] 
		   					:> Hold[({intype}->outtype) hd2]
		   			];
		   			
	(* Remove @ style for the Input, Output, InOut *)
	oldparamstyle =
		   	(HoldForm[{params}] //.
		   		HoldPattern[(prefix:Input|Output|InOut)[s_]] :> prefix s
		   	);

	useInputParamsFlag=(oldparamstyle===HoldForm[List[]]);
	   	
	(* Make a list of matching output types and params *)
	Do[(* This loops ends with a breaking if statement  *)
	tmp = {
				Cases[oldparamstyle, 
						HoldPattern[(t:InOut|Output) v_]:>Hold[v], {2}]
			,
				(* If ExternalFunction drop the first type *)
				If[externaltype===ExternalFunction,
					(* Check that there is a output type *)
					If[Length[#]>0,
						Drop[#,1]
					,
						Throw[
							Message[bodyConvExternal::noouttype, HoldForm[hd]];
						$Failed
						]
					]	
				,
					#
				]&[				
			    (* Compute the list of output types *)
			    List @@ (Hold /@
				Replace[
					(* All ArrayOf must be removed for the rules below, JG 980703 *)
					funcsign /. HoldPattern[ArrayOf[type_,{dims___}]]:> type[dims],
					{
					 Hold[({types___}-> (Null|{})) hd2_[args___]] 
								:> {},
					 Hold[({types___}-> {outtypes__}) hd2_[args___]] 
								:> Hold[outtypes],
					 Hold[({types___}-> outtype_) hd2_[args___]] 
								:> Hold[outtype]}
				])]
			};
			
	 (* Print["tmp: ",tmp]; *)
	 
	 If[Length[tmp[[1]]]<Length[tmp[[2]]],
	 	(* Add extra output variables automatically *)
	 	oldparamstyle = Replace[
	 		{ oldparamstyle,
	 		  removeHold[Apply[Hold,
	 		  	(HoldSymbol["mcO"<>ToString[#]])&/@Range[-Length[tmp[[1]]]+Length[tmp[[2]]]]
	 		   		/. Hold[x_Symbol] :> Hold[Output x]
	 		  ]]
	 		},
	 		{HoldForm[{orgparams___}], Hold[newparams__]}:>
	 		HoldForm[{orgparams,newparams}]
	 	],
	 	(* Exit the loop *)
	 	Break[]
	 ],{2}];
	(*Print["DoEnded"];*) 
        sq=inparams;
        (*Print["sq ",FullForm[sq]];*)   
	
     (*   Print["oldparamstyle_After1 End: ",FullForm[oldparamstyle]];*)   
   (*     joined=Join[sq,	oldparamstyle[[1]]];
   (*        Print["oldparamstyle_After2 Join: ",FullForm[joined]];*)
         oldparamstyle=removeHold[joined]; *)
         If[useInputParamsFlag,
            oldparamstyle=removeHold[Apply[HoldForm,List[Join[sq,  Map[Hold,oldparamstyle,2]  [[1]] [[1]]  ]]]]
        ];
     (*   oldparamstyle=Join[sq, Map[Hold,oldparamstyle,2][[1]][[1]] ];*)
        
       (* Print["oldparamstyle_After Join3: ",FullForm[oldparamstyle]];*)
   
           
	   			
     (ReleaseHold[ Hold[
			Write[file,
			"externinfo ","\"",(ExternalPrefix /. Automatic->""), "\" ",
						"\"", (ExternalContext /. Automatic->""), "\" ",
						"\"", ExternalLanguage ,"\" ",
				Which[
					externaltype===ExternalProcedure, "procedure",
					externaltype===ExternalFunction, "function",
					externaltype===ExternalVariable, "variable"
				],
				" (",
				SequenceForm@@ 
					Interleave[
						StringReplace[#, {"["->"(", "]"->")"}]& /@
						 (ToStringContextFree /@ Thread[nparams])
					,
						", "
					],
				");"
		]] /. {opts} /. Options[externaltype]
		(* Prepare the function parameter format including array size
		   dimensions *)
		/. nparams ->
		   (
		    oldparamstyle
		   	
		   	(* List for replacing symbols corresponding to array dimensions
		   	   with dimesion initialization *)
		   	/.
		    Apply[List,
		   		Replace[
		   			funcsign
		   			,
		   			(* Use paramDim2 to produce a Hold expression with
		   		 	  the array sizes initialised with the correct values *)
					{
						Hold[({types___}-> outtype_) hd2_[args___]] /;
							!FreeQ[Hold[types], Verbatim[Pattern]]
						:> paramDim2[Hold[types], Hold[args]]
					,
						(* If there are no patterns in types no rules should be
						   created *)
						_ :> {}
					}
				]
				(* Replace all = with :> *)
				/. HoldPattern[Set[s_,e_]] :> RuleDelayed[s, s = e]
				(* Replace the Dimensions and Part expression with the
				omath4 format *)
				/. HoldPattern[Dimensions[s_][[n__]]] :>
					"dim"[s,n]
			]
			
			
			(* If the parameters contains prefixed Input, Output, InOut
			   the order
			   		prefix (s = expr)
			   is changed to
			   		(prefix s) = expr
			 *)
			 /. HoldPattern[prefix_ (s_ = expr_)] :> ((prefix s) = expr)
		) 
	(* Prepare formatting of output array dimensions *)
	/.
		If[externaltype===ExternalVariable,
			{}
		,
			
			Module[{outtypes, inouts, outs},
			
			(* Print["oldparamstyle: ",oldparamstyle];
			Print["funcsign: ",funcsign];
			*)
			outtypes = Cases[oldparamstyle, 
						HoldPattern[(t:InOut|Output) v_]:>t, {2}];
				
			(* tmp is defined *)
			
			If[
				Length[tmp[[1]]] =!=  Length[tmp[[2]]]
			,
				Throw[
					Message[bodyConvExternal::outuneq,
						tmp[[2]] /. Hold->HoldForm,
						tmp[[1]] /. Hold->HoldForm,
						HoldForm[hd]];
					$Failed
				]
			];
			
			(* Create the rules *)
			Flatten[
				Delete[
					Thread[tmp],
					Position[outtypes, InOut]
				] /.
					{
						{Hold[outpar_], Hold[type_[dims__]]} :>
							(HoldPattern[outpar]:>outpar[dims]),
						{_Hold, _Hold} :> {}
					}
				] 
		   ]
		]
	]
);
];

EndFunction[];



























































BeginFunction[makeForeignDefinition]

makeForeignDefinition::usage = "makeForeignDefinition[fsymb] or makeForeignDefinition[Hold[fsymb]] produces a held expression in which the typed definition of fsymb is placed with the right hand side replaced by ExternalFunction[].\n Example: makeForeignDefinition[foo1] returns\n\tHold[(Real->Real) foo1[Foo`Private`x_] := ExternalFunction[ExternalPrefix->\"prefix\",ExternalContext->\"context`\"]";

SetAttributes[makeForeignDefinition,{HoldAll}];

makeForeignDefinition[fname_Symbol] := Module[{prefix,cnxt,fdef,context,lhs,
	bodyhead, bodyargs, bodyopts},

		cnxt = findContextOf[fname];
		
		(* Change "System`" to "system`" *)
		If[cnxt === "System`", cnxt = "system`"];

		If[(fdef = getDefinition[fname,True])=!=Null,
			(* Extract and separate possible external body *)
			{bodyhead, bodyargs, bodyopts} = {Null, Hold[], {}};
			
			Replace[standardizeTypes[fdef],
				Hold[(Set|SetDelayed)[$$Decl[_,_,_],
						(head:(ExternalFunction |
						 ExternalProcedure |
						 ExternalVariable))[args___, opts:((Rule|RuleDelayed)[___]...)]
					]] :> 
					({bodyhead, bodyargs, bodyopts} = {head, Hold[args], {opts}})
			];
			(* Extract typed head *)					
			fdef = Drop[First[Cases[standardizeTypes[fdef],_$$Decl,2]],1];
			
			If[ bodyhead === Null,
				(* Body of the function is not external or it does not exist *)
				Switch[fdef,
					(* Procedure definition *)
					$$Decl[_->(Null|{}),_],
						bodyhead = ExternalProcedure,
					(* Function definition *)
					$$Decl[_->_, _],
						bodyhead = ExternalFunction,
					(* Variable definition *)
					$$Decl[_,_],
						bodyhead = ExternalVariable
				]
			];
			
			(* Fill in the external options *)
			bodyopts = Thread[(First /@ Options[bodyhead]) ->
				          ((First /@ Options[bodyhead])/.Join[ bodyopts, Options[bodyhead] ])
				       ] /. {
				       			(ExternalPrefix->Automatic)->
				       				(ExternalPrefix -> StringDrop[cnxt,-1]<>"_T"),
				       			(ExternalContext->Automatic)->
				       				(ExternalContext -> cnxt)
				       		};
			
			(* Create the returning expression *)
			ReplacePart[
				Replace[
					{ bodyhead, bodyargs, bodyopts },
					{ { ExternalVariable, Hold[ba___], {bo___} } :>
					  Hold[lhs = ExternalVariable[ ba, bo ]],
					  { bh_, Hold[ba___], {bo___} } :>
					  Hold[lhs := bh[ ba, bo ]]
					}
				]
				,
					fdef, {1,1}
			] /. $$Decl -> Times
		]
];
		
makeForeignDefinition[Hold[fname_Symbol]] := makeForeignDefinition[fname];

EndFunction[]

















BeginFunction[writeCallBacksMCI];

writeCallBacksMCI::usage="writeCallBacksMCI[file, {funs__Hold}] writes callback definitions in the MathCode internal format.";

writeCallBacksMCI[file_, {funs__Hold}] := Module[{TYPE, ARGS, res},
	res = removeHold /@
	Cases[{funs},
		Hold[s_Symbol] :> (
			If[hasTypeInfoQ[s],
				(* If a normal typed definition exists, replace the body
				with ExternalFunction, with the language set to Mma to
				indicate for om4 converter that this is a call back function. *)
				(* Check first if the function returns a value *)
				If[ MatchQ[standardizeTypes@ getDefinition[s],
										Hold[$$Decl[_,_->({}|Null),_] := _ ]],
					(* No return value *)
					Replace[getDefinition[s],
						Hold[lhs_ := rhs_]:>
							Hold[lhs := ExternalProcedure[ExternalLanguage->"Mma"]]
					]
				,
					(* Returns value *)
					Replace[getDefinition[s],
						Hold[lhs_ := rhs_]:>
							Hold[lhs := ExternalFunction[ExternalLanguage->"Mma"]]
					]
				]
			,
				(* If function is only declared and no normal definition exists,
				   create a function head with as many parameters as number of types
				   for function arguments. *)
				Hold[(TYPE s[ARGS]) := ExternalFunction[ExternalLanguage->"Mma"]] /.
					{TYPE -> mc$$DeclaredFuncTypes[s][[1]],
					 ARGS -> Hold@@ (Pattern[#,Blank[]]&/@
					 	Table[Unique[],{Length[mc$$DeclaredFuncTypes[s][[1,1]]]}])
					}
			])
	];
	Scan[defConv[file,#,True]&, res];
];

writeCallBacksMCI[file_, {}] := Null;

EndFunction[];











BeginFunction[ConvMap];

ConvMap::usage="ConvMap[Hold[Map[f,expr,level]] transform a Map expression into a Table expression, where the dimensions of expr determines the size of the result. The mapping function f can be a typed function or a pure function (Function[]) with only one argument. The level can be used to specify at what level the mapping function should be applied, MathCode supports only singel levels, i.e. the level is of the form {n} where n is an integer given at compile time.";

ConvMap::FunctionType="Unsupported conversion of pure function `1` mapped on the expression `2`.";

(* Case 1: Most common case. A function is mapped on level 1 *)
ConvMap[Hold[Map[f_Symbol,expr_]]] := 
	(* Create an unique iterator variable, and put it in to the right places
	   in the final expression *)
	Replace[ 
		Unique[], 	
		i_Symbol :> 
		Hold[Table[f[expr\[LeftDoubleBracket]i\[RightDoubleBracket]], {i,Length[expr]}]] (* Final expression template *)
	];

		
(* Case 2: Mapping of a pure function on level 1 *)
ConvMap[Hold[Map[f:Function[__],expr_]]] := 
	removeHold@
	Replace[ Unique[],	(* Create a unique iterator variable *)
		i_Symbol :>
		Replace[
			Which[
				 (* If no formal list of arguments, assume the use of Slot[1] *)
				MatchQ[f, HoldPattern[Function[_]]],
					(* Replace Slot[1] with part of expression *)
					(Hold@@f) /. HoldPattern[Slot[1]] :> Hold[expr[[i]]],
				(* If formal list of argument exists, replace occurances of this
					argument in body with part of expression *)
				MatchQ[f, HoldPattern[Function[{_},_]]],
					(Hold@@f) /. f[[1,1]] :> Hold[expr[[i]]],
				(* If single formal  argument exists, replace occurances of this
					argument in body with part of expression *)
				MatchQ[f, HoldPattern[Function[_,_]]],
					(Hold@@f) /. f[[1]] :> Hold[expr[[i]]],	
				(* Error if non of these cases match *)
				True,
					Throw[	
						Message[ConvMap::FunctionType,f,expr];
						$Failed
					]
			],		
			HoldPattern[Hold[body_] | Hold[_,body_]] :>
			Hold[Table[body, {i,Length[expr]}]]	(* Final expression template *)
		]
	];
	
(* Case 3: Map of function of pure function with specified level *)
ConvMap[Hold[Map[f:(_Symbol|Function[___]), expr_, {lev_Integer}]]] := 
	removeHold@
	Replace[
				(* Create a list of unique iterator variables,
				   and a temporary variable that will be used to 
				   precalculated the dimension of expression. *)
		Replace[{Table[Unique[],{lev}], Unique[]},
				HoldPattern[{{itervars__}, tmpvar_}] :>
				{	
					 (* List of iterator variables *)
					{itervars},
					
					(* List of iterator variables in pair with dimension depth
					for each level of expr *)
		 			Thread[{{itervars},Array[Hold[tmpvar[[#]]]&,{lev}]}],
		 			
		 			(* temporary variable for storage of dimension *)
		 			tmpvar,
		 			
		 			(* Function body tranformation *)
		 			Which[
		 				(* If funciton is a symbol *)
		 				MatchQ[f,_Symbol],
		 					Hold[f[expr\[LeftDoubleBracket]itervars\[RightDoubleBracket]]],
		 				(* If function is a pure function with Slot arguments *)
						MatchQ[f, HoldPattern[Function[_]]],
							(Hold@@f) /. HoldPattern[Slot[1]] :> Hold[expr\[LeftDoubleBracket]itervars\[RightDoubleBracket]],
						(* If function is a pure function with namned arguments *)
						MatchQ[f, HoldPattern[Function[{_},_]]],
							(Hold@@f) /. f[[1,1]] :> Hold[expr\[LeftDoubleBracket]itervars\[RightDoubleBracket]],
						(* If function is a pure function with single namned argument *)
						MatchQ[f, HoldPattern[Function[_,_]]],
							(Hold@@f) /. f[[1]] :> Hold[expr\[LeftDoubleBracket]itervars\[RightDoubleBracket]],	
						(* If non of the above matches, ERROR *)
						True,
							Throw[	
								Message[ConvMap::FunctionType,f,expr];
								$Failed
							]
					]
		 		}
		],
		HoldPattern[{{iters__}, {ranges__},dim_, Hold[body_] | Hold[_,body_]}] :>
		
		(* Final expression template *)
		Hold[
			Module[{Integer[_] dim},
				dim = Dimensions[expr];
				Table[body, ranges]
			]
		]
	];
	
	(* Case 4: Error for all other variants of Map *)
	ConvMap[Hold[expr:Map[___]]] := (
		Throw[Message[ConvMap::unsup,HoldForm[expr]];$Failed];
		Hold[$Failed]
	);
	
	ConvMap::unsup="The expression `1` cannot be converted.";
	
	EndFunction[];

























BeginFunction[ConvApply];

ConvApply::usage = "ConvApply, the MathCode Apply converter supports the following cases:\n
1. Apply of Plus, Times and Power with assignment to a typed variable, e.g.,\n
\t var = Plus @@ expr\n
where expr is a expression returning a list with elements of the same type as declared by var. \n
2. Apply of typed functions, e.g.,\n\t
	foo @@ expr\n
  where the number of input arguments of foo is assumed to be the same as the number of elements in expr.\n
3. Apply of pure functions, Function[body] and Function[{vars..},body], e.g.,
	Sin[#1+#2]& @@ expr\n
   where the number of arguments of the pure function must be the same as the length of expr. The number of arguments is computed as the maximum Slot-number or the length of the variable list {vars...}.\n\n
   
Note that the expression expr given to apply may be computed many times, which will decrease performance if the expr is a big expression. In such case it is better to assign expression to a temporary variable before the using Apply.\n
No level specification of Apply is supported.";


(* Case 1: var = Apply[Plus|Times|Power, expr] *)
ConvApply[Hold[(sop:Set | SetDelayed)[var_, Apply[op:Plus|Times|Power, expr_]]]] := 
(
Hold[
	sop[var, expr[[1]] ];
	Do[
		sop[var, op[var, expr[[mctmp]] ]],
		{mctmp, 2, Dimensions[expr][[1]]}
	]
	(*var *)
]);

(* Case 2: Pure function with slot arguments: *)
ConvApply[Hold[Apply[Function[body_], expr_]]] := 
	If[FreeQ[Hold[body], SlotSequence],
		(* Return the body of the function with the
		   Slots replaced by parts of expr *)
		Hold[body] /.
		(* Create Slot replacements rule as
			Slot[1] :> expr[[1]], ... Slot[n]:>expr[[n]] *)
		((HoldPattern[Verbatim[Slot][#]]:>expr[[#]])& /@
			Range[
				(* Compute the maximum slot number in body *)
				Max[Cases[Hold[body], HoldPattern[Slot[x_]]:>x, Infinity]]
			])
	,
		Throw[Message[ConvApply::slotseq,
				HoldForm[Apply[Function[body], expr]]];$Failed];
			Hold[$Failed]
		
	];

(* Case 2A: Set or SetDelayed with Pure function with slot arguments: *)
ConvApply[Hold[(sop:Set | SetDelayed)[var_,Apply[Function[body_], expr_]]]] := 
	If[FreeQ[Hold[body], SlotSequence],
		(* Return the body of the function with the
		   Slots replaced by parts of expr *)
		Hold[sop[var,body]] /.
		(* Create Slot replacements rule as
			Slot[1] :> expr[[1]], ... Slot[n]:>expr[[n]] *)
		((HoldPattern[Verbatim[Slot][#]]:>expr[[#]])& /@
			Range[
				(* Compute the maximum slot number in body *)
				Max[Cases[Hold[body], HoldPattern[Slot[x_]]:>x, Infinity]]
			])
	,
		Throw[Message[ConvApply::slotseq,
				HoldForm[Apply[Function[body], expr]]];$Failed];
			Hold[$Failed]
		
	];

ConvApply::slotseq="SlotSequence cannot be converted in `1`.";
	
(* Case 3: Pure function with named arguments - unclear what is it and this is not documented in compilable subset *)
ConvApply[Hold[Apply[Function[{vars__},body_], expr_]]] :=
	(
	(* Return the body of the function with the
	   vars replaced by parts of expr *)
	Hold[body] /.
	(* Create Slot replacements rule as
		var1 :> expr[[1]], ... varn:>expr[[n]] *)
	((Extract[Hold[vars],{#},HoldPattern]:>expr[[#]])& /@
		Range[
			(* Compute the number of variables in function *)
			Length[Hold[vars]]
		])
		);

(* Case 4: Apply of typed functions *)				
ConvApply[Hold[Apply[func_Symbol?hasTypeInfoQ, expr_]]] :=
	(	
	Replace[
		(* Function name *)		
		{Hold[func],
		(* Parts of expr corresp. to the number of input parameters *) 
		(Hold @@ Range[
			Length[( (* Number of input parameter *)
				standardizeTypes[Hold[Evaluate[
					getTypeInfo[func][[2]]]]
				])[[1,2,1]]
			]
		]) /. i_Integer :> expr[[i]]
		}
	,
		{Hold[f_], Hold[args___]} :> Hold[f[args]]
	]);
	
(* Case 4A: Apply of typed functions with Set or SetDelayed (added case 050421) *)				
ConvApply[Hold[(sop:Set | SetDelayed)[var_, Apply[func_Symbol?hasTypeInfoQ, expr_]]]] :=
	(	
	Replace[
		(* Function name *)		
		{Hold[func],
		(* Parts of expr corresp. to the number of input parameters *) 
		(Hold @@ Range[
			Length[( (* Number of input parameter *)
				standardizeTypes[Hold[Evaluate[
					getTypeInfo[func][[2]]]]
				])[[1,2,1]]
			]
		]) /. i_Integer :> expr[[i]]
		}
	,
		{Hold[f_], Hold[args___]} :> Hold[sop[var,f[args]]]
	]);	
	
(* Case 5: Other cases ERROR *)

ConvApply::error="The use of Apply in `1` is not supported.";

ConvApply[Hold[stmt:(Apply[___] | (Set|SetDelayed)[_,_Apply])]] :=
	(
		Throw[Message[ConvApply::error, HoldForm[stmt]]; $Failed];
		Hold[ $Failed]
	);
	
EndFunction[];







































iteratorHeads = (Do | Table | Array);





BeginFunction[replaceIterators]

replaceIterators[
Hold[(blocktype:(Module | Block | With))[{localvar___}, body_]]] := 
  Module[{newbody, rules, newlocalvars, res}, 
   iterSymbols = Hold[localvar];
  
   rules = {newbody -> 
       ReplaceAllHoldFuncRepeated[Hold[body], 
        HoldPattern[Do[iterbody_, __] | Do[iterbody_] |
           (Set | SetDelayed)[_, Table[iterbody_, __]] | 
           (Set | SetDelayed)[_, Array[iterbody_ & , __]] /; 
          (FreeQ[Unevaluated[iterbody], iteratorHeads])], IterTrans], 
      newlocalvars -> {iterSymbols}};
    iterSymbols = Hold[]; 
    res = removeHold[Hold[blocktype[newlocalvars, newbody]] /. rules];
    
    Cases[res, HoldPattern[expr:(Table|Array)[___]]:>
    			Throw[Message[replaceIterators::error, HoldForm[expr]];$Failed],
    			{1,Infinity}
    ];
    res
    ];
    
replaceIterators::error="The expression `1` cannot be converted to a Do[] loop. This expression in MathCode can be placed in the right-hand-side of assignment only.";  
    
replaceIterators[Hold[expr__ /; !FreeQ[Unevaluated[expr],iteratorHeads]]] := replaceIterators[Hold[Module[{},expr]]]

replaceIterators[x_Hold] := x

EndFunction[]







BeginFunction[IterTrans]

IterTrans[Hold[Do[expr_,iter__]]] := Fold[templateDo, Hold[expr],Unevaluated/@Reverse[Hold[iter]]];

IterTrans[Hold[Do[expr_]]]:=Hold[expr];



IterTrans[Hold[(op:(Set|SetDelayed))[var_,Table[expr_,iter__]]]]:=
  Module[{dimension,initp,newiter,r1,r2,r3,offset,held,ni,ix,newsymbsrules,tmp,s},
        If[Not[MatchQ[Hold[Unevaluated[var]],Hold[_?AtomQ]]],
            Message[IterTrans::notAvariable]
        ];
       
		dimension=
       (Hold[iter] /.
           {{n_}:>Max[n,0],
            {_,n_}:>Max[n,0],
            {_,start_,stop_}:>(Max[stop-start+1,0]),
            {_,start_,stop_,step_}:>Max[1+Floor[(stop-start)/step],0]}
        );
		newiter = ReplaceAllHoldFunc[
					Hold[iter],
					{n_},
					removeHold[Hold@@ {{Unique[], Extract[#,{1,1},Hold]}}]&
					];
	
		tmp = Cases[newiter,{s_,x__}:>{s,Unique[s],Hold[x]}];
		newsymbsrules = Reverse@
				Apply[Rule,
					Map[Take[#,2]&,tmp],
					{1}
				];
		newiter = removeHold[Hold@@ Map[Drop[#,1]&,tmp]];
		r1 = initp->setshape[Hold[var],Hold@@dimension];
		r2 = ix-> Hold@@ (newiter/.
							{{i_,_}->i,
								{i_,start_,_}->i-start+1,
								{i_,start_,_,step_}->
									NaturalDivide[i-start,step]+1}); (* Works only for positive t*)
		r3 = ni-> (Hold@@ newiter);
		removeHold[Hold[initp;Do[op[var[[ix]],expr],ni]] /. Flatten@{newsymbsrules,r1,r2,r3}]
		]

IterTrans[
    Hold[(op:(Set|SetDelayed))[var_,
        Array[Function[body_ /; FreeQ[Unevaluated[body],Slot|SlotSequence]],
          {iter__}]]]]:=Module[{initp,newiter,r1,r2,r3},
		newiter = Table[Unique[],{Length[Hold[iter]]}];
		r1 = initp->setshape[Hold[var],Hold[iter]];
		r2 = ix-> Hold @@ newiter;
		r3 = ni-> Thread[{Hold@@ newiter,Hold[iter]},Hold];
		removeHold[Hold[initp;Do[op[var[[ix]],body],ni]] /. {r1,r2,r3} ]
		]

IterTrans[  Hold[(Set|SetDelayed)[var_,  Array[expr_,iter_]]]]:= (
		Message[IterTrans::arraycomperr,HoldForm[var] ,HoldForm[expr],
      HoldForm[iter]]);
      
IterTrans::notAvariable = "Not a variable on left hand side of assignment Expr:=Table[]. Only variables are permitted there.  Part expressions A[[B]] are not permitted there.";
IterTrans::arraycomperr = "Error when compiling `1`:= Array[...].\n
				Check that: 1. `2` is a Function[] without arguments returning scalars. \
2. The dimension `3` is a list at compile time.";
			
EndFunction[]





























BeginFunction[templateDo]

templateDo::impossibleIterator="This variant of iterator `1` is not permitted in MathCode. Typically for compilation the tripple {symbol,start,end} should be used.";

templateDo[Hold[body_],HoldPattern[{s_Symbol,start_,end_}]]:=
		Replace[
			Hold[s, body] /. uniqueIteratorRule[s],
			Hold[iter_, nbody_] :>
				Hold[
					For[iter = start, iter <= end, iter++,
						nbody
					]
				]
		];

templateDo[Hold[body_],
    HoldPattern[{s_Symbol,start_,end_,step_?NumberQ/;Positive[step]}]]:=
		Replace[
			Hold[s, body] /. uniqueIteratorRule[s],
			Hold[iter_, nbody_] :>
				Hold[
					For[iter = start, iter <= end, iter= iter+step,
						nbody
					]
				]
		];
			
templateDo[Hold[body_],
    HoldPattern[{s_Symbol,start_,end_,step_?NumberQ/;Negative[step]}]]:=
		Replace[
			Hold[s, body] /. uniqueIteratorRule[s],
			Hold[iter_, nbody_] :>
				Hold[
					For[iter = start, iter >= end, iter= iter+step,
						nbody
					]
				]
		];

templateDo[Hold[body_],HoldPattern[{s_Symbol,start_,end_,step_}]]:=
		Replace[
			Hold[s, body] /. uniqueIteratorRule[s],
			Hold[iter_, nbody_] :>
				Hold[
					For[iter = start, 0<= Sign[step](end-iter), iter= iter+step,
						nbody
					]
				]
		];

templateDo[Hold[body_],HoldPattern[{s_Symbol,end_}]]:=
		Replace[
			Hold[s, body] /. uniqueIteratorRule[s],
			Hold[iter_, nbody_] :>
				Hold[
					For[iter = 1, iter <= end, iter++,
						nbody
					]
				]
		];

templateDo[Hold[body_],HoldPattern[{end_}]]:=
		Replace[
			Hold[s, body] /. uniqueIteratorRule[],
			Hold[iter_, nbody_] :>
				Hold[
					For[iter = 1, iter <= end, iter++,
						nbody
					]
				]
		];
		
templateDo[Hold[body_],HoldPattern[z:{___}]]:=
(
Message[templateDo::impossibleIterator,z];
Null
);

templateDo[Hold[body_],HoldPattern[end_]]:=
		Replace[
			Hold[s, body] /. uniqueIteratorRule[],
			Hold[iter_, nbody_] :>
				Hold[
					For[iter = 1, iter <= end, iter++,
						nbody
					]
				]
		];

EndFunction[]









iterSymbols=Hold[];

BeginFunction[uniqueIteratorRule]

uniqueIteratorRule[s_Symbol] := Module[{newsymb},
	If[True || !FreeQ[iterSymbols,s], (* Always generate unique names *)
			newsymb = Unique[s];
			AppendTo[iterSymbols,Hold[Integer #]&[newsymb]];
			s -> newsymb
		,
			AppendTo[iterSymbols,Hold[Integer s]];
			{}         (* No exchande of iterator will be performed *)
		]
	]

uniqueIteratorRule[] := Module[{newsymb},
	newsymb = Unique[];
	AppendTo[iterSymbols,Hold[Integer #]&[newsymb]];
	s -> newsymb
	]

EndFunction[]



On[General::"spell"];
On[General::"spell1"];

(* Close the package *)
EndPackage[];